# CDDLib

[![](https://github.com/JuliaPolyhedra/CDDLib.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaPolyhedra/CDDLib.jl/actions/workflows/ci.yml)
[![](http://codecov.io/github/JuliaPolyhedra/CDDLib.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaPolyhedra/CDDLib.jl?branch=master)
[![](https://zenodo.org/badge/DOI/10.5281/zenodo.1214581.svg)](https://doi.org/10.5281/zenodo.1214581)

[CDDLib.jl](https://github.com/JuliaPolyhedra/CDDLib.jl) is a wrapper for
[cddlib](https://www.inf.ethz.ch/personal/fukudak/cdd_home/).

CDDLib.jl can be used with C API of cddlib, the higher level interface of [Polyhedra.jl](https://github.com/JuliaPolyhedra/Polyhedra.jl),
or as a linear programming solver with [JuMP](https://github.com/jump-dev/JuMP.jl)
or [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl).

## Problem description

As written in the [README of cddlib](https://github.com/cddlib/cddlib):

> The C-library  cddlib is a C implementation of the Double Description
> Method of Motzkin et al. for generating all vertices (that is, extreme points)
> and extreme rays of a general convex polyhedron in R^d given by a system
> of linear inequalities:
> ```
> P = { x=(x1, ..., xd)^T :  b - A  x  >= 0 }
> ```
> where  A  is a given m x d real matrix, b is a given m-vector
> and 0 is the m-vector of all zeros.
>
> The program can be used for the reverse operation (that is, convex hull
> computation).  This means that  one can move back and forth between
> an inequality representation  and a generator (that is, vertex and ray)
> representation of a polyhedron with cdd.  Also, cdd can solve a linear
> programming problem, that is, a problem of maximizing and minimizing
> a linear function over P.

## License

CDDLib.jl is licensed under the [GPL v2 license](https://github.com/JuliaPolyhedra/CDDLib.jl/blob/master/LICENSE.md).

The underlying solver, [cddlib/cddlib](https://github.com/cddlib/cddlib) is
also licensed under the [GPL v2 license](https://github.com/cddlib/cddlib/blob/master/COPYING).

## Installation

Install CDDLib.jl using the Julia package manager:

```julia
import Pkg
Pkg.add("CDDLib")
```

Building the package will download binaries of [cddlib](https://github.com/cddlib/cddlib)
that are provided by [cddlib_jll.jl](https://github.com/JuliaBinaryWrappers/cddlib_jll.jl).

## Use with JuMP

Use `CDDLib.Optimizer{Float64}` to use CDDLib.jl with [JuMP](https://github.com/jump-dev/JuMP.jl):

```julia
using JuMP, CDDLib
model = Model(CDDLib.Optimizer{Float64})
```

When using CDDLib.jl with [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl),
you can pass a different number type:
```julia
using MathOptInterface, CDDLib
model = CDDLib.Optimizer{Rational{BigInt}}()
```

## Debugging

CDDLib.jl uses two global Boolean variables to enable debugging outputs: `debug` and
`log`.

You can query the value of `debug` and `log` with `get_debug` and `get_log`,
and set their values with `set_debug` and `set_log`.

module CDDLib

using LinearAlgebra
import cddlib_jll: libcddgmp
using Polyhedra

include("ccall.jl")

function __init__()
    @dd_ccall set_global_constants Nothing ()
end

import Base.convert, Base.push!, Base.eltype, Base.copy

include("debug_log.jl")
include("cddtypes.jl")
include("error.jl")
include("mytype.jl")
include("settype.jl")

include("matrix.jl")
include("polyhedra.jl")
include("operations.jl")
include("lp.jl")

include("MOI_wrapper.jl")
include("polyhedron.jl")

end # module

function _invalid(x)
    err = ErrorException("Invalid coefficient : `$x` is not finite.")
    @test_throws err polyhedron(convexhull([x]), CDDLib.Library())
    @test_throws err polyhedron(intersect(HalfSpace([x], zero(x))), CDDLib.Library())
    @test_throws err polyhedron(intersect(HyperPlane([one(x)], -x)), CDDLib.Library())
end

@testset "Infinite $x" for x in [1 // 0, -2 // 0, NaN, Inf, -Inf]
    _invalid(x)
end

@testset "myerror" begin
    err = ErrorException("A : Dimension too large")
    @test_throws err CDDLib.myerror("A", CDDLib.Cdd_ErrorType(0))
    err = ErrorException("A gave an error code of 18 which is out of the range of known error code. Pleasre report this by opening an issue at https://github.com/JuliaPolyhedra/CDDLib.jl.")
    @test_throws err CDDLib.myerror("A", CDDLib.Cdd_ErrorType(18))
    err = ErrorException("A gave an error code of -1 which is out of the range of known error code. Pleasre report this by opening an issue at https://github.com/JuliaPolyhedra/CDDLib.jl.")
    @test_throws err CDDLib.myerror("A", CDDLib.Cdd_ErrorType(-1))
end

const error_message = [
  "Dimension too large",
  "Improper input format",
  "Negative matrix size",
  "Empty V representation",
  "Empty H representation",
  "Empty Representation",
  "Input file not found",
  "Output file not open",
  "No LP objective",
  "No real number support",
  "Not available for H",
  "Not available for V",
  "Cannot handle linearity",
  "Row index out of range",
  "Col index out of range",
  "LP cycling",
  "Numerically inconsistent",
]

function myerror(func_name::String, err::Cdd_ErrorType)
    idx = err + 1
    if idx in eachindex(error_message)
        error(func_name, " : ", error_message[err+1])
    elseif err != length(error_message) # 17 means no error
        error("$func_name gave an error code of $err which is out of the range of known error code. Pleasre report this by opening an issue at https://github.com/JuliaPolyhedra/CDDLib.jl.")
    end
end
function myerror(func_name::String, ptr::Ptr, err::Cdd_ErrorType)
    myerror(func_name, err)
    if ptr == C_NULL
        error("$func_name returned a NULL pointer but did not provide any error. Please report this by opening an issue at https://github.com/JuliaPolyhedra/CDDLib.jl.")
    end
end

function dd_set_initialize(maxel::Clong)
    x = Ref{Cset_type}(0)
    @cdd_ccall set_initialize Nothing (Ref{Ptr{Culong}}, Clong) x maxel
    x[]
end

function dd_set_addelem(st::Cset_type, el::Clong)
    @cdd_ccall set_addelem Nothing (Cset_type, Clong) st convert(Clong, el)
end

function dd_set_member(st::Cset_type, el::Clong)
    1 == (@cdd_ccall set_member Cint (Clong, Cset_type) el st)
end
dd_set_member(st::Cset_type, el) = dd_set_member(st, Clong(el))

function dd_set_card(st::Cset_type)
    @cdd_ccall set_card Clong (Cset_type,) st
end

function dd_settype(st::Cset_type, s, offset::Integer=0)
    for el in s
        dd_set_addelem(st, Clong(offset+el))
    end
end

# CDDSet

mutable struct CDDSet
    s::Cset_type
    maxel::Clong
end

function CDDSet(s, maxel::Clong, offset::Integer)
    st = dd_set_initialize(maxel)
    dd_settype(st, s, offset)
    CDDSet(st, maxel)
end
CDDSet(s, maxel, offset::Integer) = CDDSet(s, Clong(maxel), offset)

function dd_free(set::CDDSet)
    @cdd_ccall(set_free, Cvoid, (Cset_type,), set.s)
end

function Base.convert(::Type{BitSet}, st::CDDSet)
    s = BitSet()
    for i = 1:st.maxel
        if dd_set_member(st.s, convert(Clong, i))
            push!(s, i)
        end
    end
    s
end

# I don't want it to overwrite Base.convert behaviour
function myconvert(::Type{BitSet}, a::Matrix)
    b = Array{Bool}(a)
    s = BitSet()
    for i = 1:length(a)
        if b[i]
            push!(s, i)
        end
    end
    s
end

mutable struct SetFamily
    famsize::Cdd_bigrange
    setsize::Cdd_bigrange
    set::Cdd_SetVector
end

function dd_free(set::Ptr{SetFamily})
    @dd_ccall(FreeSetFamily, Cvoid, (Ptr{SetFamily},), set)
end

function Base.convert(::Type{Vector{BitSet}}, set_familty_ptr::Ptr{SetFamily})
    set_family = unsafe_load(set_familty_ptr)
    sets = unsafe_wrap(Array, set_family.set, set_family.famsize)
    return BitSet[convert(BitSet, CDDSet(set, set_family.setsize)) for set in sets]
end

function convert_free(::Type{T}, x) where {T}
    t = convert(T, x)
    dd_free(x)
    return t
end

export CDDSet

import Base.+, Base.-, Base.*, Base.promote_rule, Base.==, Base.zero

# It is immutable so that it is stored by value in the structures
# GMPRational and GMPRationalMut and not by reference
struct GMPInteger
    alloc::Cint
    size::Cint
    data::Ptr{UInt32}
end

mutable struct GMPRationalMut
    num::GMPInteger
    den::GMPInteger

    function GMPRationalMut()
        m = new()
        ccall((:__gmpq_init, :libgmp), Nothing, (Ptr{GMPRationalMut},), Ref(m))
        # No need to clear anything since the num and den are used by
        # the GMPRational that is created
        #finalizer(_mpq_clear_fn, m)
        m
    end
end

function Base.convert(::Type{GMPRationalMut}, a::Rational{BigInt})
    m = GMPRationalMut()
    ccall((:__gmpq_set_num, :libgmp), Nothing,
          (Ptr{GMPRationalMut}, Ptr{BigInt}), Ref(m), Ref(a.num))
    ccall((:__gmpq_set_den, :libgmp), Nothing,
          (Ptr{GMPRationalMut}, Ptr{BigInt}), Ref(m), Ref(a.den))
    m
end
Base.convert(::Type{GMPRationalMut}, a::Rational) = GMPRationalMut(Rational{BigInt}(a))
Base.convert(::Type{GMPRationalMut}, a::AbstractFloat) = GMPRationalMut(Rational(a))

# Can do it faster for Int
function GMPRationalMut(a::Int, b::Int)
    if b < 0
        a = -a
        b = -b
    end
    m = GMPRationalMut()
    ccall((:__gmpq_set_si, :libgmp), Nothing,
          (Ptr{GMPRationalMut}, Clong, Culong), Ref(m), a, b)
    m
end
Base.convert(::Type{GMPRationalMut}, a::Int) = GMPRationalMut(a, 1)
Base.convert(::Type{GMPRationalMut}, a::Rational{Int}) = GMPRationalMut(a.num, a.den)

Base.zero(::Type{GMPRationalMut}) = GMPRationalMut(0)

# I cannot have a finalizer for an immutable so you are responsibe to free it
# if you use it using e.g. myfree define below
struct GMPRational <: Real
    num::GMPInteger
    den::GMPInteger
    function GMPRational(m::GMPRationalMut)
        r = new(m.num, m.den)
        r
    end
end

function myfree(a::Array{Cdouble})
    # nothing to free
end
function myfree(a::Array{GMPRational})
    for el in a
        ccall((:__gmpq_clear, :libgmp), Nothing, (Ptr{GMPRational},), Ref(el))
    end
end

Base.convert(::Type{GMPRational}, x::GMPRationalMut) = GMPRational(x)

GMPRational() = GMPRational(GMPRationalMut())

GMPRational(a::S, b::T) where {T<:Integer,S<:Integer} = GMPRational(GMPRationalMut(a, b))
Base.convert(::Type{GMPRational}, a::T) where {T<:Real} = convert(GMPRational, convert(GMPRationalMut, a))
Base.convert(::Type{GMPRational}, a::GMPRational) = a

Base.zero(::Type{GMPRational}) = convert(GMPRational, 0)

# The default zeros uses the same rational for each element
# so each element has the same data1 and data2 pointers...
# This is why I need to redefine it
function Base.zeros(::Type{GMPRational}, dims::Union{Integer, AbstractUnitRange}...)
    ret = Array{GMPRational}(undef, dims...)
    for i in eachindex(ret)
        ret[i] = Base.zero(GMPRational)
    end
    ret
end

function -(a::GMPRational)
    m = GMPRationalMut()
    ccall((:__gmpq_neg, :libgmp), Nothing,
          (Ptr{GMPRationalMut}, Ptr{GMPRational}), Ref(m), Ref(a))
    GMPRational(m)
end
function *(a::GMPRational, b::GMPRational)
    m = GMPRationalMut()
    ccall((:__gmpq_mul, :libgmp), Nothing,
          (Ptr{GMPRationalMut}, Ptr{GMPRational}, Ptr{GMPRational}), Ref(m), Ref(a), Ref(b))
    GMPRational(m)
end
function +(a::GMPRational, b::GMPRational)
    m = GMPRationalMut()
    ccall((:__gmpq_add, :libgmp), Nothing,
          (Ptr{GMPRationalMut}, Ptr{GMPRational}, Ptr{GMPRational}), Ref(m), Ref(a), Ref(b))
    GMPRational(m)
end

# Debug
function Base.show(io::IO, x::GMPInteger)
    show(io, (x.alloc, x.size, unsafe_load(x.data)))
end

function Base.show(io::IO, x::GMPRational)
    show(io, convert(Rational, x))
end

function Base.convert(::Type{Rational{BigInt}}, r::GMPRational)
    a = BigInt()
    ccall((:__gmpq_get_num, :libgmp), Nothing,
          (Ptr{BigInt}, Ptr{GMPRational}), Ref(a), Ref(r))
    b = BigInt()
    ccall((:__gmpq_get_den, :libgmp), Nothing,
          (Ptr{BigInt}, Ptr{GMPRational}), Ref(b), Ref(r))
    a // b
end
Base.convert(::Type{Rational}, r::GMPRational) = Base.convert(Rational{BigInt}, r)
# I need to define the following conversion because of ambuity with Real -> Bool
Base.convert(::Type{Rational{T}}, a::GMPRational) where {T<:Integer} = Base.convert(Rational{T}, convert(Rational, a))
Base.convert(::Type{Bool}, a::GMPRational) = Base.convert(Bool, convert(Rational, a))
Base.convert(::Type{T}, a::GMPRational) where {T<:Integer} = Base.convert(T, convert(Rational, a))

promote_rule(::Type{GMPRational}, ::Type{T}) where {T<:Integer} = GMPRational

==(x::GMPRational, y::GMPRational) = Rational(x) == Rational(y)

const PolyType = Union{Rational{BigInt}, Cdouble}
const MyType = Union{GMPRational, Cdouble}

mytype(::Type{Cdouble}) = Cdouble
mytype(::Type{Rational{BigInt}}) = GMPRational
polytype(::Type{Cdouble}) = Cdouble
polytype(::Type{GMPRational}) = Rational{BigInt}

mytypefor(::Type{T}) where {T <: Real}          = GMPRational
mytypefor(::Type{T}) where {T <: AbstractFloat} = Cdouble
mytypefor(::Type{T}) where {T <: MyType}        = T
polytypefor(::Type{T}) where {T <: Real}          = Rational{BigInt}
polytypefor(::Type{T}) where {T <: AbstractFloat} = Cdouble
polytypefor(::Type{T}) where {T <: PolyType}        = T

# Used by mathprogbase.jl
function myconvert(::Type{Array}, x::Ptr{T}, n) where T<:Union{Cdouble, Clong}
    copy(unsafe_wrap(Array, x, n))
end
function myconvert(::Type{Array}, x::Ptr{GMPRational}, n)
    y = Vector{GMPRationalMut}(undef, n)
    for i = 1:n
        y[i] = GMPRationalMut()
        ccall((:__gmpq_set, :libgmp), Nothing, (Ptr{GMPRationalMut}, Ptr{GMPRational}), pointer_from_objref(y[i]), x+((i-1)*sizeof(GMPRational)))
    end
    Vector{GMPRational}(y)
end

export MyType, GMPRational

const Cdd_boolean = Cint

const Cdd_rowrange = Clong
const Cdd_colrange = Clong
const Cdd_bigrange = Clong

const Cset_type = Ptr{Culong}
const Cdd_rowset = Cset_type
const Cdd_colset = Cset_type

const Cdd_rowindex = Ptr{Clong}
const Cdd_rowflag = Ptr{Cint}
const Cdd_colindex = Ptr{Clong}

const Cdd_Amatrix{T} = Ptr{Ptr{T}}
const Cdd_Arow{T} = Ptr{T}

const Cdd_SetVector = Ptr{Cset_type}
const Cdd_Bmatrix{T} = Ptr{Ptr{T}}
const Cdd_Aincidence = Ptr{Cset_type}

primitive type Cdd_DataFileType 2040 end # char[255]

const Cdd_NumberType = Cint
# dd_Unknown=0, dd_Real, dd_Rational, dd_Integer
const dd_Unknown  = 0
const dd_Real     = 1
const dd_Rational = 2
const dd_Integer  = 3

const Cdd_RepresentationType = Cint
# dd_Unspecified=0, dd_Inequality, dd_Generator
const dd_Unspecified = 0
const dd_Inequality  = 1
const dd_Generator   = 2

const Cdd_ConversionType = Cint
# dd_IneToGen, dd_GenToIne, dd_LPMax, dd_LPMin, dd_InteriorFind

const Cdd_IncidenceOutputType = Cint
# dd_IncOff=0, dd_IncCardinality, dd_IncSet

const Cdd_AdjacencyOutputType = Cint
# dd_AdjOff=0, dd_AdjacencyList,  dd_AdjacencyDegree

const Cdd_FileInputModeType = Cint
# dd_Auto, dd_SemiAuto, dd_Manual
# Auto if a input filename is specified by command arguments

const Cdd_ErrorType = Cint
# dd_DimensionTooLarge, dd_ImproperInputFormat,
# dd_NegativeMatrixSize, dd_EmptyVrepresentation, dd_EmptyHrepresentation, dd_EmptyRepresentation,
# dd_IFileNotFound, dd_OFileNotOpen, dd_NoLPObjective, dd_NoRealNumberSupport,
# dd_NotAvailForH, dd_NotAvailForV, dd_CannotHandleLinearity,
# dd_RowIndexOutOfRange, dd_ColIndexOutOfRange,
# dd_LPCycling, dd_NumericallyInconsistent,
# dd_NoError

const Cdd_CompStatusType = Cint
# dd_InProgress, dd_AllFound, dd_RegionEmpty

# LP types

const Cdd_LPObjectiveType = Cint
# dd_LPnone=0, dd_LPmax, dd_LPmin
const dd_LPnone = Cint(0)
const dd_LPmax  = Cint(1)
const dd_LPmin  = Cint(2)

const Cdd_LPSolverType = Cint
# dd_CrissCross, dd_DualSimplex
const dd_CrissCross  = Cint(0)
const dd_DualSimplex = Cint(1)

const Cdd_LPStatusType = Cint
# dd_LPSundecided, dd_Optimal, dd_Inconsistent, dd_DualInconsistent,
# dd_StrucInconsistent, dd_StrucDualInconsistent,
# dd_Unbounded, dd_DualUnbounded
const dd_LPSundecided          = Cint(0)
const dd_Optimal               = Cint(1)
const dd_Inconsistent          = Cint(2)
const dd_DualInconsistent      = Cint(3)
const dd_StrucInconsistent     = Cint(4)
const dd_StrucDualInconsistent = Cint(5)
const dd_Unbounded             = Cint(6)
const dd_DualUnbounded         = Cint(7)

const Ctime_t = Clong # FIXME Cint in some systems ?

using Test
using Polyhedra
using CDDLib

@testset "Via shooting $(via_shooting)" for via_shooting in [false, true]
    @testset "Redundant test $precision" for precision in [:float, :exact]
        lib = CDDLib.Library(precision)
        V = [3 0; 1 1; 0 3; 0 0]
        p = polyhedron(vrep(V), lib)
        @test p isa CDDLib.Polyhedron{precision == :float ? Float64 : Rational{BigInt}}
        @test collect(CDDLib.getvredundantindices(p; via_shooting)) == [2]

        A = [1 0; 1 1; 0 1; -1 0; 0 -1]
        b = [1, 2, 1, 1, 1]
        p = polyhedron(hrep(A, b), lib)
        @test p isa CDDLib.Polyhedron{precision == :float ? Float64 : Rational{BigInt}}
        @test collect(CDDLib.gethredundantindices(p; via_shooting)) == [2]
    end
end

function debug_log_test(getter, setter)
    @test getter() == 0
    setter(true)
    @test getter() == 1
    setter(false)
    @test getter() == 0
end
@testset "debug and log" begin
    debug_log_test(get_debug, set_debug)
    debug_log_test(get_log, set_log)
end

@testset "Low-level permutahedron tests" begin
    A = [1 1 1; 1 0 0; 0 1 0; 0 0 1; -1 0 0; 0 -1 0; 0 0 -1]
    b = [6, 3, 3, 3, -1, -1, -1]
    ls = BitSet([1])
    V = [2 3 1; 1 3 2; 3 1 2; 3 2 1; 2 1 3; 1 2 3]
    ine = hrep(A, b, ls)
    #@test !isempty(ine)
    inef = hrep(Array{Float64}(A), Array{Float64}(b), ls)
    #@test !isempty(inef)
    poly = CDDPolyhedra(ine)
    polyf = CDDPolyhedra(inef)
    ineoutm  = copyinequalities(poly)
    ineoutmf = copyinequalities(polyf)
    extm     = copygenerators(poly)
    extmf    = copygenerators(polyf)
    @test string(unsafe_load(ineoutm.matrix)) == "H-representation
linearity 1 1
begin
 7 4 rational
 6//1 -1//1 -1//1 -1//1
 3//1 -1//1 0//1 0//1
 3//1 0//1 -1//1 0//1
 3//1 0//1 0//1 -1//1
 -1//1 1//1 0//1 0//1
 -1//1 0//1 1//1 0//1
 -1//1 0//1 0//1 1//1
end"
    @test string(unsafe_load(ineoutmf.matrix)) == "H-representation
linearity 1 1
begin
 7 4 real
 6.0 -1.0 -1.0 -1.0
 3.0 -1.0 -0.0 -0.0
 3.0 -0.0 -1.0 -0.0
 3.0 -0.0 -0.0 -1.0
 -1.0 1.0 -0.0 -0.0
 -1.0 -0.0 1.0 -0.0
 -1.0 -0.0 -0.0 1.0
end"
    @test string(unsafe_load(extm.matrix)) == "V-representation
begin
 6 4 rational
 1//1 2//1 3//1 1//1
 1//1 1//1 3//1 2//1
 1//1 3//1 1//1 2//1
 1//1 3//1 2//1 1//1
 1//1 2//1 1//1 3//1
 1//1 1//1 2//1 3//1
end"
    @test string(unsafe_load(extmf.matrix)) == "V-representation
begin
 6 4 real
 1.0 2.0 3.0 0.9999999999999998
 1.0 0.9999999999999997 3.0 2.0
 1.0 3.0000000000000004 1.0 1.9999999999999993
 1.0 3.0 2.0 0.9999999999999997
 1.0 1.9999999999999991 1.0 2.9999999999999996
 1.0 0.9999999999999996 2.0 3.0
end"
    ineout  = MixedMatHRep{Int}(ineoutm)
    ineoutf = MixedMatHRep{Int}(ineoutmf)
    ext     = MixedMatVRep{Int}(extm)
    extf    = MixedMatVRep(extmf)
    inequality_simpletest(ineout, A, b, ls)
    inequality_simpletest(ineoutf, A, b, ls)
    R = Matrix{Int}(undef, 0, 3)
    generator_simpletest(ext, V, R)
    generator_simpletest(extf, V, R)


    # x1___x4____________1
    #      |         |
    #      V         V
    # x2___x5___x6_______2
    #           |
    #           V
    # x3_________________3
    Alift = [-1  0  0  1  0  0;
              0 -1  0  1  0  0;
             -1 -1  0  1  1  0;
              1  1  0 -1 -1  0;
              0  0 -1  0  0  1;
              0  0  0  0 -1  1;
              0  0 -1  0 -1  1;
              0  0  1  0  1 -1;
              0  0  0 -1  0  0;
              0  0  0  0  0 -1;
              0  0  0 -1  0 -1;
              0  0  0  1  0  1]
    blift = [0; 0; 0; 0; 0; 0; -3; 3; -1; -1; -(1+2); (1+2)]
    linsetlift = BitSet()
    inelift3 = hrep(Alift, blift, linsetlift)
    inelift3f = MixedMatHRep{Float64}(inelift3)
    inelift2 = fourierelimination(inelift3)
    inelift2f = fourierelimination(inelift3f)
    inelift1 = blockelimination(inelift2)
    inelift1f = blockelimination(inelift2f)
    inelift0 = blockelimination(inelift1, BitSet([fulldim(inelift1)]))
    inelift0f = blockelimination(inelift1f, BitSet([fulldim(inelift1f)]))
    canonicalize!(inelift0)
    canonicalize!(inelift0f)
    inelift0d = MixedMatHRep{Int}(inelift0)
    inelift0df = MixedMatHRep{Int}(inelift0f)
    @test inelift0d.linset == BitSet(1)
    @test length(inelift0d.b) == 7
    @test inelift0d.b[1] / sign(inelift0d.b[1]) == 6
    @test vec(Array{Int}(inelift0d.A[1,:] / sign(inelift0d.b[1]))) == [1; 1; 1] # Array{Int} cast and vec are for julia 0.4
    @test inelift0df.linset == BitSet(1)
    @test length(inelift0df.b) == 7
    @test inelift0df.b[1] / sign(inelift0df.b[1]) == 6
    @test vec(Array{Int}(inelift0df.A[1,:] / sign(inelift0df.b[1]))) == [1; 1; 1] # Array{Int} cast and vec are for julia 0.4
    polylift = CDDPolyhedra(inelift0)
    polyliftf = CDDPolyhedra(inelift0f)
    extunlift = MixedMatVRep{Int}(copygenerators(polylift))
    extunliftf = MixedMatVRep(copygenerators(polyliftf))
    generator_simpletest(extunlift, V, R)
    generator_simpletest(extunliftf, V, R)
end

mutable struct Cdd_MatrixData{T <: MyType}
    rowsize::Cdd_rowrange
    linset::Cdd_rowset
    colsize::Cdd_colrange
    representation::Cdd_RepresentationType
    numbtype::Cdd_NumberType
    matrix::Ptr{Ptr{T}}
    objective::Cdd_LPObjectiveType
    rowvec::Ptr{T}
end

function dd_creatematrix(::Type{Cdouble}, m::Cdd_rowrange, n::Cdd_colrange)
    @ddf_ccall CreateMatrix Ptr{Cdd_MatrixData{Cdouble}} (Cdd_rowrange, Cdd_colrange) m n
end
function dd_creatematrix(::Type{GMPRational}, m::Cdd_rowrange, n::Cdd_colrange)
    @dd_ccall CreateMatrix Ptr{Cdd_MatrixData{GMPRational}} (Cdd_rowrange, Cdd_colrange) m n
end

# function dd_copyAmatrixvectorizedbycolumn(mat::Cdd_Amatrix{Cdouble}, M::Matrix{Cdouble}, m::Cdd_rowrange, n::Cdd_colrange)
#   @ddf_ccall CopyAmatrixVectorizedByColumn Nothing (Cdd_Amatrix{Cdouble}, Ptr{Cdouble}, Cdd_rowrange, Cdd_colrange) mat M m n
# end
# function dd_copyAmatrixvectorizedbycolumn(mat::Cdd_Amatrix{GMPRational}, M::Matrix{GMPRational}, m::Cdd_rowrange, n::Cdd_colrange)
#   @dd_ccall CopyAmatrixVectorizedByColumn Nothing (Cdd_Amatrix{GMPRational}, Ptr{GMPRational}, Cdd_rowrange, Cdd_colrange) mat M m n
# end

function dd_copyArow(acopy::Cdd_Arow{Cdouble}, a::Vector{Cdouble})
    @ddf_ccall CopyArow Nothing (Cdd_Arow{Cdouble}, Cdd_Arow{Cdouble}, Cdd_colrange) acopy a length(a)
end
function dd_copyArow(acopy::Cdd_Arow{GMPRational}, a::Vector{Rational{BigInt}})
    b = Vector{GMPRational}(a)
    @dd_ccall CopyArow Nothing (Cdd_Arow{GMPRational}, Cdd_Arow{GMPRational}, Cdd_colrange) acopy b length(b)
    myfree(b)
end

function dd_copyArow(acopy::Cdd_Arow{T}, a::AbstractVector) where T
    return dd_copyArow(acopy, convert(Vector{polytype(T)}, a)) # e.g. for sparse a
end

function dd_setmatrixobjective(matrix::Ptr{Cdd_MatrixData{Cdouble}}, objective::Cdd_LPObjectiveType)
    @ddf_ccall SetMatrixObjective Nothing (Ptr{Cdd_MatrixData{Cdouble}}, Cdd_LPObjectiveType) matrix objective
end
function dd_setmatrixobjective(matrix::Ptr{Cdd_MatrixData{GMPRational}}, objective::Cdd_LPObjectiveType)
    @dd_ccall SetMatrixObjective Nothing (Ptr{Cdd_MatrixData{GMPRational}}, Cdd_LPObjectiveType) matrix objective
end

function dd_setmatrixnumbertype(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    @ddf_ccall SetMatrixNumberType Nothing (Ptr{Cdd_MatrixData{Cdouble}}, Cdd_NumberType) matrix dd_Real
end
function dd_setmatrixnumbertype(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    @dd_ccall SetMatrixNumberType Nothing (Ptr{Cdd_MatrixData{GMPRational}}, Cdd_NumberType) matrix dd_Rational
end

function dd_setmatrixrepresentationtype(matrix::Ptr{Cdd_MatrixData{Cdouble}}, inequality::Bool)
    @ddf_ccall SetMatrixRepresentationType Nothing (Ptr{Cdd_MatrixData{Cdouble}}, Cdd_RepresentationType) matrix (inequality ? dd_Inequality : dd_Generator)
end
function dd_setmatrixrepresentationtype(matrix::Ptr{Cdd_MatrixData{GMPRational}}, inequality::Bool)
    @dd_ccall SetMatrixRepresentationType Nothing (Ptr{Cdd_MatrixData{GMPRational}}, Cdd_RepresentationType) matrix (inequality ? dd_Inequality : dd_Generator)
end

function dd_matrixcopy(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    @ddf_ccall MatrixCopy Ptr{Cdd_MatrixData{Cdouble}} (Ptr{Cdd_MatrixData{Cdouble}},) matrix
end
function dd_matrixcopy(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    @dd_ccall MatrixCopy Ptr{Cdd_MatrixData{GMPRational}} (Ptr{Cdd_MatrixData{GMPRational}},) matrix
end

function fillmatrix(inequality::Bool, matrix::Ptr{Ptr{T}}, itr, linset::BitSet, offset) where T
    for (i, item) in enumerate(itr)
        row = unsafe_load(matrix, offset+i)
        if islin(item)
            push!(linset, offset + i)
        end
        # CDD is expected <a, x> >= 0 but Polyhedra uses <a, x> <= 0
        a = vec(coord(lift(item)))
        for i in eachindex(a)
            if !isfinite(a[i])
                error("Invalid coefficient : `$(a[i])` is not finite.")
            end
        end
        dd_copyArow(row, inequality ? -a : a)
    end
end

# If ElemIt contains AbstractVector{T}, we cannot infer FullDim so we add both as argument
function initmatrix(d::Polyhedra.FullDim, ::Type{T}, inequality::Bool, itr::Polyhedra.ElemIt...) where {T}
    n = fulldim(d)+1
    cs = cumsum(collect(length.(itr))) # cumsum not defined for tuple :(
    m = cs[end]
    offset = [0; cs[1:end-1]]
    matrix = dd_creatematrix(mytype(T), Cdd_rowrange(m), Cdd_colrange(n))
    mat = unsafe_load(matrix)
    linset = BitSet()
    fillmatrix.(inequality, mat.matrix, itr, Ref(linset), offset)
    dd_settype(mat.linset, linset)
    dd_setmatrixnumbertype(matrix)
    dd_setmatrixrepresentationtype(matrix, inequality)
    matrix
end

# Representation

mutable struct CDDInequalityMatrix{T <: PolyType, S <: MyType} <: Polyhedra.MixedHRep{T}
    matrix::Ptr{Cdd_MatrixData{S}}

    function CDDInequalityMatrix{T, S}(matrix::Ptr{Cdd_MatrixData{S}}) where {T <: PolyType, S <: MyType}
        @assert polytype(S) == T
        m = new{T, S}(matrix)
        finalizer(myfree, m)
        m
    end

end

mutable struct CDDGeneratorMatrix{T <: PolyType, S <: MyType} <: Polyhedra.MixedVRep{T}
    matrix::Ptr{Cdd_MatrixData{S}}
    cone::Bool # If true, CDD will not return any point so we need to add the origin

    function CDDGeneratorMatrix{T, S}(matrix::Ptr{Cdd_MatrixData{S}}) where {T <: PolyType, S <: MyType}
        @assert polytype(S) == T
        cone = !iszero(_length(matrix)) # If there is no ray and no point, it is empty so we should not add the origin
        for i in 1:_length(matrix)
            if isrowpoint(matrix, i, T)
                cone = false
                break
            end
        end
        m = new{T, S}(matrix, cone)
        finalizer(myfree, m)
        m
    end
end

const CDDMatrix{T, S} = Union{CDDInequalityMatrix{T, S}, CDDGeneratorMatrix{T, S}}
CDDMatrix{T}(rep) where {T} = CDDMatrix{T, mytype(T)}(rep)
Polyhedra.FullDim(rep::CDDMatrix) = Int(unsafe_load(rep.matrix).colsize) - 1
Polyhedra.hvectortype(::Union{CDDInequalityMatrix{T}, Type{<:CDDInequalityMatrix{T}}}) where {T} = Vector{T}
Polyhedra.vvectortype(::Union{CDDGeneratorMatrix{T}, Type{<:CDDGeneratorMatrix{T}}}) where {T} = Vector{T}
Polyhedra.similar_type(::Type{<:CDDInequalityMatrix}, ::Polyhedra.FullDim, ::Type{T}) where {T} = CDDInequalityMatrix{T, mytype(T)}
Polyhedra.similar_type(::Type{<:CDDGeneratorMatrix}, ::Polyhedra.FullDim, ::Type{T}) where {T} = CDDGeneratorMatrix{T, mytype(T)}

function linset(matrix::CDDMatrix)
    mat = unsafe_load(matrix.matrix)
    Base.convert(BitSet, CDDSet(mat.linset, mat.rowsize))
end

CDDMatrix(hrep::HRepresentation) = CDDInequalityMatrix(hrep)
CDDMatrix(vrep::VRepresentation) = CDDGeneratorMatrix(vrep)
cddmatrix(::Type{T}, hrep::HRepresentation) where {T} = convert(CDDInequalityMatrix{T, mytype(T)}, hrep)
cddmatrix(::Type{T}, vrep::VRepresentation) where {T} = convert(CDDGeneratorMatrix{T, mytype(T)}, vrep)
#(::Type{CDDMatrix{T,S}}){T,S}(hrep::HRepresentation) = CDDInequalityMatrix{T,S}(hrep)
#(::Type{CDDMatrix{T,S}}){T,S}(vrep::VRepresentation) = CDDGeneratorMatrix{T,S}(vrep)
# Does not work
#Base.convert{T,S}(::Type{CDDMatrix{T,S}}, vrep::VRepresentation) = CDDGeneratorMatrix{T,S}(vrep)

function _length(matrix::Ptr{Cdd_MatrixData{S}}) where S
    mat = unsafe_load(matrix)
    Int(mat.rowsize)
end
Base.length(matrix::CDDInequalityMatrix) = _length(matrix.matrix)
Base.length(matrix::CDDGeneratorMatrix) = _length(matrix.matrix) + matrix.cone

function dd_freematrix(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    @ddf_ccall FreeMatrix Nothing (Ptr{Cdd_MatrixData{Cdouble}},) matrix
end
function dd_freematrix(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    @dd_ccall FreeMatrix Nothing (Ptr{Cdd_MatrixData{GMPRational}},) matrix
end
function myfree(matrix::CDDMatrix)
    dd_freematrix(matrix.matrix)
end

Polyhedra.done(idxs::Polyhedra.Indices{T, ElemT, <:CDDMatrix{T}}, idx::Polyhedra.Index{T, ElemT}) where {T, ElemT} = idx.value > length(idxs.rep)
Base.get(hrep::CDDMatrix{T}, idx::Polyhedra.Index{T}) where {T} = Polyhedra.valuetype(idx)(extractrow(hrep, idx.value)...)

# H-representation

CDDInequalityMatrix(rep::Rep{T}) where {T} = convert(CDDInequalityMatrix{polytypefor(T), mytypefor(T)}, rep)

CDDInequalityMatrix(matrix::Ptr{Cdd_MatrixData{T}}) where {T} = CDDInequalityMatrix{polytype(T), T}(matrix)

function CDDInequalityMatrix{T, S}(d::Polyhedra.FullDim, hits::Polyhedra.HIt{T}...) where {T, S}
    CDDInequalityMatrix(initmatrix(d, T, true, hits...))
end

nhreps(matrix::CDDInequalityMatrix) = length(matrix)
neqs(matrix::CDDInequalityMatrix) = dd_set_card(unsafe_load(matrix.matrix).linset)
Base.length(idxs::Polyhedra.Indices{T, <:HyperPlane{T}, <:CDDInequalityMatrix{T}}) where {T} = neqs(idxs.rep)
Base.length(idxs::Polyhedra.Indices{T, <:HalfSpace{T}, <:CDDInequalityMatrix{T}}) where {T} = nhreps(idxs.rep) - neqs(idxs.rep)

function Base.copy(matrix::CDDInequalityMatrix{T, S}) where {T, S}
    CDDInequalityMatrix{T, S}(dd_matrixcopy(matrix.matrix))
end

function extractrow(mat::Cdd_MatrixData{Cdouble}, i)
    @assert 1 <= i <= mat.rowsize
    n = mat.colsize
    b = Vector{Cdouble}(undef, n)
    row = unsafe_load(mat.matrix, i)
    for j = 1:n
        b[j] = unsafe_load(row, j)
    end
    b
end

function extractrow(mat::Cdd_MatrixData{GMPRational}, i)
    @assert 1 <= i <= mat.rowsize
    n = mat.colsize
    b = Vector{GMPRationalMut}(undef, n)
    row = unsafe_load(mat.matrix, i)
    for j = 1:n
        b[j] = GMPRationalMut()
        ccall((:__gmpq_set, :libgmp), Nothing, (Ptr{GMPRationalMut}, Ptr{GMPRational}), pointer_from_objref(b[j]), row + ((j-1)*sizeof(GMPRational)))
    end
    Array{Rational{BigInt}}(Array{GMPRational}(b))
end

function extractrow(ine::CDDInequalityMatrix, i)
    mat = unsafe_load(ine.matrix)
    b = extractrow(mat, i)
    β = b[1]
    a = -b[2:end]
    return a, β
end
function extractrow(ext::CDDGeneratorMatrix{T}, i) where {T}
    if ext.cone && i == nvreps(ext)
        a = Polyhedra.origin(Polyhedra.vvectortype(ext), fulldim(ext))
    else
        mat = unsafe_load(ext.matrix)
        row = extractrow(mat, i)
        a = row[2:end]
    end
    return (a,) # Needs to be a tuple, see Base.get(::CDDMatrix, ...)
end
function _row_is_point(row::Vector)
    is_point = row[1]
    if iszero(row[1])
        return false
    elseif isone(row[1])
        return true
    elseif abs(row[1]) < 1e-7
        # Close to zero so we will assume it is zero.
        # See https://github.com/JuliaPolyhedra/CDDLib.jl/issues/38
        return false
    else
        error("The first entry of the row of a CDD V-representation should either be 0 if the rest of the row is a ray or 1 if it is a point but it is `$(row[1])`, please report this.")
    end
end
function isrowpoint(matrix::Ptr{Cdd_MatrixData{S}}, i, ::Type{T}) where {S, T}
    mat = unsafe_load(matrix)
    b = extractrow(mat, i)
    return _row_is_point(b)
end
function isrowpoint(ext::CDDGeneratorMatrix{T}, i) where {T}
    (ext.cone && i == nvreps(ext)) || isrowpoint(ext.matrix, i, T)
end
_islin(rep::CDDMatrix, idx::Polyhedra.Index) = dd_set_member(unsafe_load(rep.matrix).linset, idx.value)
Polyhedra.islin(hrep::CDDInequalityMatrix{T}, idx::Polyhedra.HIndex{T}) where {T} = _islin(hrep, idx)
Polyhedra.islin(vrep::CDDGeneratorMatrix{T}, idx::Polyhedra.VIndex{T}) where {T} = !(vrep.cone && idx.value == nvreps(vrep)) && _islin(vrep, idx)

function Base.isvalid(hrep::CDDInequalityMatrix{T}, idx::Polyhedra.HIndex{T}) where {T}
    0 < idx.value <= length(hrep) && Polyhedra.islin(hrep, idx) == islin(idx)
end

function isaninequalityrepresentation(matrix::CDDInequalityMatrix)
    true
end

function setobjective(matrix::CDDInequalityMatrix{T}, c, max_sense) where {T}
    dd_setmatrixobjective(matrix.matrix, max_sense ? dd_LPmax : dd_LPmin)
    obj = [zero(T); convert(Vector{T}, c)]
    dd_copyArow(unsafe_load(matrix.matrix).rowvec, obj)
end

# V-representation

CDDGeneratorMatrix(rep::Rep{T}) where {T} = convert(CDDGeneratorMatrix{polytypefor(T), mytypefor(T)}, rep)

CDDGeneratorMatrix(matrix::Ptr{Cdd_MatrixData{T}}) where {T} = CDDGeneratorMatrix{polytype(T), T}(matrix)

function Base.copy(matrix::CDDGeneratorMatrix{T, S}) where {T, S}
    CDDGeneratorMatrix{T, S}(dd_matrixcopy(matrix.matrix))
end

function CDDGeneratorMatrix{T,S}(d::Polyhedra.FullDim, vits::Polyhedra.VIt{T}...) where {T, S}
    CDDGeneratorMatrix(initmatrix(d, T, false, vits...))
end

nvreps(matrix::CDDGeneratorMatrix) = length(matrix)
function Base.length(idxs::Polyhedra.PointIndices{T, <:CDDGeneratorMatrix{T}}) where {T}
    if idxs.rep.cone
        1
    else
        Polyhedra.mixedlength(idxs)
    end
end

function Base.isvalid(vrep::CDDGeneratorMatrix{T}, idx::Polyhedra.VIndex{T}) where {T}
    isp = isrowpoint(vrep, idx.value)
    isl = Polyhedra.islin(vrep, idx)
    @assert !isp || !isl # if isp && isl, it is a symmetric point but it is not allowed to mix symmetric points and points
    0 < idx.value <= length(vrep) && isl == islin(idx) && isp == ispoint(idx)
end

isaninequalityrepresentation(matrix::CDDGeneratorMatrix) = false

function extractA(mat::Cdd_MatrixData{Cdouble})
    m = mat.rowsize
    n = mat.colsize
    A = Array{Cdouble, 2}(undef, m, n)
    for i = 1:m
        row = unsafe_load(mat.matrix, i)
        for j = 1:n
            A[i,j] = unsafe_load(row, j)
        end
    end
    A
end

function extractA(mat::Cdd_MatrixData{GMPRational})
    m = mat.rowsize
    n = mat.colsize
    A = Array{GMPRationalMut, 2}(undef, m, n)
    for i = 1:m
        row = unsafe_load(mat.matrix, i)
        for j = 1:n
            A[i, j] = GMPRationalMut()
            ccall((:__gmpq_set, :libgmp), Nothing, (Ptr{GMPRationalMut}, Ptr{GMPRational}), pointer_from_objref(A[i,j]), row + ((j-1)*sizeof(GMPRational)))
        end
    end
    Array{GMPRational}(A)
end

function Base.show(io::IO, matrix::Cdd_MatrixData{T}) where T
    if matrix.representation == dd_Inequality
        println(io, "H-representation")
    else
        println(io, "V-representation")
    end

    linsize = dd_set_card(matrix.linset)
    if linsize > 0
        print(io, "linearity $linsize");
        for i in 1:matrix.rowsize
            if dd_set_member(matrix.linset, i)
                print(io, " $i")
            end
        end
        println(io)
    end

    println(io, "begin")
    println(io, " $(matrix.rowsize) $(matrix.colsize) $(T == Cdouble ? "real" : "rational")")
    A = extractA(matrix)
    for i = 1:size(A, 1)
        for j = 1:size(A, 2)
            print(io, " $(A[i, j])")
        end
        println(io)
    end
    print(io, "end")

    if matrix.objective > 0
        println(io)
        println(io, matrix.objective == 1 ? "maximize" : "minimize")
        for i = 1:matrix.colsize
            print(io, " $(unsafe_load(matrix.rowvec, i))")
        end
    end

end

export CDDMatrix, CDDInequalityMatrix, CDDGeneratorMatrix, isaninequalityrepresentation

function inequality_simpletest(ine::Polyhedra.MixedMatHRep, A, b, linset)
    @test A == ine.A
    @test b == ine.b
    @test linset == ine.linset
end
inequality_simpletest(ine::HRepresentation, A, b, linset) = inequality_simpletest(MixedMatHRep(ine), A, b, linset)
function generator_simpletest(ext::MixedMatVRep, V, R = Matrix{eltype(V)}(undef, 0, size(V, 2)))
    @test sortslices(V, dims=1) == sortslices(round.(ext.V), dims=1)
    @test sortslices(R, dims=1) == sortslices(round.(ext.R), dims=1)
end
generator_simpletest(ext::VRepresentation, V, R = Matrix{eltype(V)}(undef, 0, size(V, 2))) = generator_simpletest(MixedMatVRep(ext), V, R)

using LinearAlgebra

@testset "Low-level board tests" begin
    A1 = -Matrix(1I, 9, 9) # x >= 0
    b1 = zeros(Int, 9)
    A2 = Matrix(1I, 9, 9) # x <= 1
    b2 = ones(Int, 9)
    A3 = zeros(Int, 9, 9)
    b3 = 3 * ones(Int, 9)
    i = 1
    for a = 1:3
        for b = (a+1):3
            for c = 1:3
                for d = (c+1):3
                    ac = a + (c-1) * 3
                    ad = a + (d-1) * 3
                    bc = b + (c-1) * 3
                    bd = b + (d-1) * 3
                    A3[i, ac] = 1
                    A3[i, ad] = 1
                    A3[i, bc] = 1
                    A3[i, bd] = 1
                    i += 1
                end
            end
        end
    end
    A = [A1; A2; A3]
    b = [b1; b2; b3]
    ine = hrep(A, b)
    poly = CDDPolyhedra(ine)
    ext  = Polyhedra.MixedMatVRep{Rational{Int}}(copygenerators(poly))
    target = ones(Int, 9) * (3 // 4)
    ok = false
    for v in points(ext)
        if v == target
            ok = true
        end
    end
    @test ok

    cutA = ones(Int, 1, 9)
    cutb = 6
    Acut = [cutA; A]
    bcut = [cutb; b]
    inecut = hrep(Acut, bcut)
    (isredundant, certificate) = redundant(inecut, 1)
    @test !isredundant
    @test Array{Rational{Int}}(certificate) == target
    redundantrows(inecut)
    @test BitSet() == redundantrows(inecut)
    (issredundant, scertificate) = sredundant(inecut, 1)
    @test !issredundant
    @test Array{Rational{Int}}(scertificate) == target
end

using CDDLib

# returns extreme points of polyhedron Ax <= b
function extremepoints(A,b)
    m = HRepresentation(A, b)
    p = CDDPolyhedra(m)
    EPs = Representation{Rational{BigInt}}(copygenerators(p))
    splitvertexrays!(EPs)
    return EPs.V, EPs.R
end

A = [-1 0; 0 -1; 1 1]
b = [0, 0, 1]
println(extremepoints(A,b))

using Test
using Polyhedra
using CDDLib

@testset "Incidence tests" begin
    @testset "Incidence $precision" for precision in [:float, :exact]
        A = [1 1; 1 -1; -1 0]; b = [1, 0, 0]
        incidence_extected = Set([
            BitSet([1, 2]),
            BitSet([1, 3]),
            BitSet([2, 3])
        ])
        p = polyhedron(hrep(A, b), CDDLib.Library(precision))
        @test p isa CDDLib.Polyhedron{precision == :float ? Float64 : Rational{BigInt}}
        vrep(p)
        @test Set(copyincidence(p.poly)) == incidence_extected
    end

    @testset "Input incidence $precision" for precision in [:float, :exact]
        V = [[1//2, 1//2], [0, 1], [0, 0]]
        p = polyhedron(vrep(V), CDDLib.Library(precision))
        hrep(p)
        hs = collect(halfspaces(p))

        incidence_computed = copyinputincidence(p.poly)
        for (vidx, v) in enumerate(points(p))
            for i in incidence_computed[vidx]
                @test Polyhedra.isincident(v, hs[i], tol=0)
            end
        end
    end

    @testset "get[hv]incidence $precision" for precision in [:float, :exact]
        A = [1 1; 1 -1; -1 0]; b = [1, 0, 0]
        p_H = polyhedron(hrep(A, b), CDDLib.Library(precision))
        vrep(p_H)

        V = [[1//2, 1//2], [0, 1], [0, 0]]
        p_V = polyhedron(vrep(V), CDDLib.Library(precision))
        hrep(p_V)

        # Homogeneous cone
        A = [-1 0; 0 -1]; b0 = [0, 0]
        p_hc = polyhedron(hrep(A, b0), CDDLib.Library(precision))

        # Non-homogeneous cone
        A = [-1 0; 0 -1]; b1 = [-1, -1]
        p_nhc = polyhedron(hrep(A, b1), CDDLib.Library(precision))

        for p in [p_H, p_V, p_hc, p_nhc]
            @inferred CDDLib.gethincidence(p)
            @inferred CDDLib.getvincidence(p)

            hs = collect(halfspaces(p))
            vs = [collect(rays(p))..., collect(points(p))...]

            T = Polyhedra.coefficient_type(p)
            tol = Polyhedra._default_tol(T)

            for (vidx, v) in enumerate(vs)
                for i in p.hincidence[vidx]
                    @test Polyhedra.isincident(v, hs[i], tol=tol)
                end
            end

            for (hidx, h) in enumerate(hs)
                for i in p.vincidence[hidx]
                    @test Polyhedra.isincident(vs[i], h, tol=tol)
                end
            end
        end
    end
end

using Test
using Polyhedra
using CDDLib

@testset "Adjacency $precision" for precision in [:float, :exact]
    vsquare = vrep([[i, j] for i in [-1, 1] for j in [-1, 1]])
    p = polyhedron(vsquare, CDDLib.Library(precision))
    @test p isa CDDLib.Polyhedron{precision == :float ? Float64 : Rational{BigInt}}
    @test matrix2adjacency(p.ext) == [
        BitSet([2, 3])
        BitSet([1, 4])
        BitSet([1, 4])
        BitSet([2, 3])
    ]
end

using Test
using Polyhedra
using CDDLib

include("errors.jl")
include("debug_log.jl")
include("polyhedral_function.jl")

using JuMP
lpsolver = tuple()

include("utils.jl")
include("redundant.jl")
include("adjacency.jl")
include("incidence.jl")
include("simplex.jl")
include("permutahedron.jl")
include("board.jl")
include("MOI_wrapper.jl")
include("polyhedron.jl")

mutable struct Cdd_LPSolutionData{T<:MyType}
    filename::Cdd_DataFileType
    objective::Cdd_LPObjectiveType
    solver::Cdd_LPSolverType
    m::Cdd_rowrange
    d::Cdd_colrange
    numbtype::Cdd_NumberType

    LPS::Cdd_LPStatusType
    # the current solution status
    optvalue::T
    # optimal value
    sol::Cdd_Arow{T}
    # primal solution
    dsol::Cdd_Arow{T}
    # dual solution
    nbindex::Cdd_colindex
    # current basis represented by nonbasic indices
    re::Cdd_rowrange
    # row index as a certificate in the case of inconsistency
    se::Cdd_colrange
    # col index as a certificate in the case of dual inconsistency
    pivots0::Clong
    pivots1::Clong
    pivots2::Clong
    pivots3::Clong
    pivots4::Clong
    # pivots[0]=setup (to find a basis), pivots[1]=PhaseI or Criss-Cross,
    # pivots[2]=Phase II, pivots[3]=Anticycling, pivots[4]=GMP postopt.
    total_pivots::Clong
end

function dd_freelpsolution(lp::Ptr{Cdd_LPSolutionData{Cdouble}})
    @ddf_ccall FreeLPSolution Nothing (Ptr{Cdd_LPSolutionData{Cdouble}},) lp
end
function dd_freelpsolution(lp::Ptr{Cdd_LPSolutionData{GMPRational}})
    @dd_ccall FreeLPSolution Nothing (Ptr{Cdd_LPSolutionData{GMPRational}},) lp
end

mutable struct CDDLPSolution{T<:MyType}
    sol::Ptr{Cdd_LPSolutionData{T}}

    function CDDLPSolution{T}(sol::Ptr{Cdd_LPSolutionData{T}}) where {T <: MyType}
        s = new{T}(sol)
        finalizer(myfree, s)
        s
    end
end

CDDLPSolution(sol::Ptr{Cdd_LPSolutionData{T}}) where {T<:MyType} = CDDLPSolution{T}(sol)

function myfree(sol::CDDLPSolution)
    dd_freelpsolution(sol.sol)
end

function getsolution(sol::CDDLPSolution{GMPRational})
    soldata = unsafe_load(sol.sol)
    solutiontmp = myconvert(Array, soldata.sol, soldata.d)
    solution = Array{Rational{BigInt}}(solutiontmp)[2:end]
    myfree(solutiontmp)
    solution
end
function getsolution(sol::CDDLPSolution{Cdouble})
    soldata = unsafe_load(sol.sol)
    solutiontmp = myconvert(Array, soldata.sol, soldata.d)
    solutiontmp[2:end]
end

function getconstrduals(sol::CDDLPSolution{GMPRational})
    soldata = unsafe_load(sol.sol)
    # -1 because there is the objective
    nbindex = myconvert(Array, soldata.nbindex, soldata.d+1)
    dsol = myconvert(Array, soldata.dsol, soldata.d+1)
    dual = zeros(Rational{BigInt}, soldata.m-1)
    for j in 2:soldata.d
        if nbindex[j+1] > 0
            dual[nbindex[j+1]] = dsol[j]
        end
    end
    myfree(dsol)
    dual
end
function getconstrduals(sol::CDDLPSolution{Cdouble})
    soldata = unsafe_load(sol.sol)
    # -1 because there is the objective
    nbindex = myconvert(Array, soldata.nbindex, soldata.d+1)
    dsol = myconvert(Array, soldata.dsol, soldata.d+1)
    dual = zeros(Cdouble, soldata.m-1)
    for j in 2:soldata.d
        if nbindex[j+1] > 0
            dual[nbindex[j+1]] = dsol[j]
        end
    end
    dual
end

mutable struct Cdd_LPData{T<:MyType}
    filename::Cdd_DataFileType
    objective::Cdd_LPObjectiveType
    solver::Cdd_LPSolverType
    Homogeneous::Cdd_boolean
    # The first column except for the obj row is all zeros.
    m::Cdd_rowrange
    d::Cdd_colrange
    A::Cdd_Amatrix{T}
    B::Cdd_Bmatrix{T}
    objrow::Cdd_rowrange
    rhscol::Cdd_colrange
    numbtype::Cdd_NumberType
    eqnumber::Cdd_rowrange
    # the number of equalities
    equalityset::Cdd_rowset

    redcheck_extensive::Cdd_boolean
    # Apply the extensive redundancy check.
    ired::Cdd_rowrange
    # the row index for the redundancy checking
    redset_extra::Cdd_rowset
    # a set of rows that are newly recognized redundan by the extensive search.
    redset_accum::Cdd_rowset
    # the accumulated set of rows that are recognized redundant
    posset_extra::Cdd_rowset
    # a set of rows that are recognized non-linearity

    lexicopivot::Cdd_boolean
    # flag to use the lexicogrphic pivot rule (symbolic perturbation).

    LPS::Cdd_LPStatusType
    # the current solution status
    m_alloc::Cdd_rowrange
    # the allocated row size of matrix A
    d_alloc::Cdd_colrange
    # the allocated col size of matrix A
    optvalue::T
    # optimal value
    sol::Cdd_Arow{T}
    # primal solution
    dsol::Cdd_Arow{T}
    # dual solution
    nbindex::Cdd_colindex
    # current basis represented by nonbasic indices
    re::Cdd_rowrange
    # row index as a certificate in the case of inconsistency
    se::Cdd_colrange
    #col index as a certificate in the case of dual inconsistency
    pivots0::Clong
    pivots1::Clong
    pivots2::Clong
    pivots3::Clong
    pivots4::Clong
    # pivots[0]=setup (to find a basis), pivots[1]=PhaseI or Criss-Cross,
    #  pivots[2]=Phase II, pivots[3]=Anticycling, pivots[4]=GMP postopt.
    total_pivots::Clong
    use_given_basis::Cint
    # switch to indicate the use of the given basis
    given_nbindex::Cdd_colindex
    # given basis represented by nonbasic indices
    starttime::Ctime_t
    endtime::Ctime_t
end

function dd_freelpdata(lp::Ptr{Cdd_LPData{Cdouble}})
    @ddf_ccall FreeLPData Nothing (Ptr{Cdd_LPData{Cdouble}},) lp
end
function dd_freelpdata(lp::Ptr{Cdd_LPData{GMPRational}})
    @dd_ccall FreeLPData Nothing (Ptr{Cdd_LPData{GMPRational}},) lp
end

mutable struct CDDLP{T<:MyType}
    lp::Ptr{Cdd_LPData{T}}

    function CDDLP{T}(lp::Ptr{Cdd_LPData{T}}) where {T <: MyType}
        l = new{T}(lp)
        finalizer(myfree, l)
        l
    end
end

CDDLP(lp::Ptr{Cdd_LPData{T}}) where {T<:MyType} = CDDLP{T}(lp)

function myfree(lp::CDDLP)
    dd_freelpdata(lp.lp)
end

function dd_matrix2feasibility(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    return @ddf_ccall_pointer_error(
        Matrix2Feasibility,
        Ptr{Cdd_LPData{Cdouble}},
        (Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end
function dd_matrix2feasibility(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    return @dd_ccall_pointer_error(
        Matrix2Feasibility,
        Ptr{Cdd_LPData{GMPRational}},
        (Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end
function matrix2feasibility(matrix::CDDInequalityMatrix)
    CDDLP(dd_matrix2feasibility(matrix.matrix))
end

function dd_matrix2lp(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    return @ddf_ccall_pointer_error(
        Matrix2LP,
        Ptr{Cdd_LPData{Cdouble}},
        (Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end
function dd_matrix2lp(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    return @dd_ccall_pointer_error(
        Matrix2LP,
        Ptr{Cdd_LPData{GMPRational}},
        (Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end
function matrix2lp(matrix::CDDInequalityMatrix)
    CDDLP(dd_matrix2lp(matrix.matrix))
end

function dd_lpsolve(lp::Ptr{Cdd_LPData{Cdouble}}, solver::Cdd_LPSolverType)
    return @ddf_ccall_error(
        LPSolve,
        Cdd_ErrorType,
        (Ptr{Cdd_LPData{Cdouble}}, Cdd_LPSolverType, Ref{Cdd_ErrorType}),
        lp,
        solver,
    )
end
function dd_lpsolve(lp::Ptr{Cdd_LPData{GMPRational}}, solver::Cdd_LPSolverType)
    return @dd_ccall_error(
        LPSolve,
        Cdd_ErrorType,
        (Ptr{Cdd_LPData{GMPRational}}, Cdd_LPSolverType, Ref{Cdd_ErrorType}),
        lp,
        solver,
    )
end
function lpsolve(lp::CDDLP, solver::Symbol=:DualSimplex)
    found = dd_lpsolve(lp.lp, solver == :DualSimplex ? dd_DualSimplex : dd_CrissCross)
    if !Bool(found)
        error("LP could not be solved")
    end
end

function dd_copylpsolution(lp::Ptr{Cdd_LPData{Cdouble}})
    @ddf_ccall CopyLPSolution Ptr{Cdd_LPSolutionData{Cdouble}} (Ptr{Cdd_LPData{Cdouble}},) lp
end
function dd_copylpsolution(lp::Ptr{Cdd_LPData{GMPRational}})
    @dd_ccall CopyLPSolution Ptr{Cdd_LPSolutionData{GMPRational}} (Ptr{Cdd_LPData{GMPRational}},) lp
end
function copylpsolution(lp::CDDLP)
    CDDLPSolution(dd_copylpsolution(lp.lp))
end

export get_debug, set_debug, get_log, set_log
_debug() = cglobal((:ddf_debug, CDDLib.libcddgmp), CDDLib.Cdd_boolean)
function get_debug()
    unsafe_load(_debug())
end
function set_debug(value)
    unsafe_store!(_debug(), value)
end
_log() = cglobal((:ddf_log, CDDLib.libcddgmp), CDDLib.Cdd_boolean)
function get_log()
    unsafe_load(_log())
end
function set_log(value)
    unsafe_store!(_log(), value)
end

using Test
import MathOptInterface as MOI
const MOIT = MOI.Test
const MOIU = MOI.Utilities
const MOIB = MOI.Bridges
using Polyhedra
using CDDLib

@testset "MOI wrapper with $T" for T in [Rational{BigInt}, Float64]
    @testset "coefficient_type" begin
        @test Polyhedra.coefficient_type(CDDLib.Optimizer{T}()) == T
    end
    optimizer = CDDLib.Optimizer{T}()
    @testset "SolverName" begin
        @test MOI.get(optimizer, MOI.SolverName()) == "CDD"
    end
    @testset "Continuous Linear problems with CDDLib.Optimizer{$T}" begin
        cache = MOIU.UniversalFallback(Polyhedra._MOIModel{T}())
        cached = MOIU.CachingOptimizer(cache, optimizer)
        bridged = MOIB.full_bridge_optimizer(cached, T)
        config = MOIT.Config(
            T,
            exclude = Any[
                MOI.ObjectiveBound,
                MOI.DualObjectiveValue,
                MOI.ConstraintDual,
                MOI.SolveTimeSec,
                MOI.SolverVersion,
                MOI.VariableBasisStatus,
                MOI.ConstraintBasisStatus,
            ]
        )
        if T == Float64
            MOIT.runtests(
                bridged,
                config,
                exclude = String[
                    # TODO investigate
                    "test_unbounded_MAX_SENSE",
                    "test_unbounded_MAX_SENSE_offset",
                    "test_unbounded_MIN_SENSE",
                    "test_unbounded_MIN_SENSE_offset",
                    # TODO Should be fixed in MOI master
                    "test_model_LowerBoundAlreadySet",
                    "test_model_UpperBoundAlreadySet",
                ],
            )
        else
            MOIT.runtests(
                bridged,
                config,
                # Other tests do not support non-`Float64`
                include = String["test_linear"],
                exclude = String[
                    "test_linear_Indicator",
                    "test_linear_SOS1",
                    "test_linear_SOS2",
                    "test_linear_Semicontinuous",
                    "test_linear_Semiinteger",
                    "test_linear_integer",
                ]
            )
        end
    end
end

struct Library <: Polyhedra.Library
    precision::Symbol

    function Library(precision::Symbol=:float)
        if !(precision in [:float, :exact])
            error("Invalid precision, it should be :float or :exact")
        end
        new(precision)
    end
end
Polyhedra.similar_library(::Library, ::Polyhedra.FullDim, ::Type{T}) where T<:Union{Integer,Rational} = Library(:exact)
Polyhedra.similar_library(::Library, ::Polyhedra.FullDim, ::Type{T}) where T<:AbstractFloat = Library(:float)

mutable struct Polyhedron{T<:PolyType} <: Polyhedra.Polyhedron{T}
    ine::Union{Nothing, CDDInequalityMatrix{T}}
    ext::Union{Nothing, CDDGeneratorMatrix{T}}
    poly::Union{Nothing, CDDPolyhedra{T}}
    hincidence::Union{Nothing, Vector{BitSet}}
    vincidence::Union{Nothing, Vector{BitSet}}
    hlinearitydetected::Bool
    vlinearitydetected::Bool
    noredundantinequality::Bool
    noredundantgenerator::Bool

    function Polyhedron{T}(ine::CDDInequalityMatrix) where {T <: PolyType}
        new{T}(ine, nothing, nothing, nothing, nothing, false, false, false, false)
    end
    function Polyhedron{T}(ext::CDDGeneratorMatrix) where {T <: PolyType}
        new{T}(nothing, ext, nothing, nothing, nothing, false, false, false, false)
    end
    # function Polyhedron(poly::CDDPolyhedra{T})
    #   new(nothing, nothing, poly)
    # end
end
Polyhedra.FullDim(p::Polyhedron{T}) where {T} = Polyhedra.FullDim_rep(p.ine, p.ext)
Polyhedra.library(p::Polyhedron{T}) where {T} = Polyhedra.similar_library(Library(), Polyhedra.FullDim(p), T)
Polyhedra.hvectortype(::Union{Polyhedron{T}, Type{<:Polyhedron{T}}}) where {T} = Polyhedra.hvectortype(CDDInequalityMatrix{T})
Polyhedra.vvectortype(::Union{Polyhedron{T}, Type{<:Polyhedron{T}}}) where {T} = Polyhedra.vvectortype(CDDGenerator{T})
Polyhedra.similar_type(::Type{<:Polyhedron}, d::Polyhedra.FullDim, ::Type{T}) where {T} = Polyhedra.default_type(d, T)
Polyhedra.similar_type(::Type{<:Polyhedron}, ::Polyhedra.FullDim, ::Type{T}) where {T<:PolyType} = Polyhedron{T}

Polyhedron(matrix::CDDMatrix{T}) where {T} = Polyhedron{T}(matrix)
Base.convert(::Type{Polyhedron{T}}, rep::Representation{T}) where {T} = Polyhedron{T}(cddmatrix(T, rep))

# Helpers
function getine(p::Polyhedron)
    if p.ine === nothing
        p.ine = copyinequalities(getpoly(p))
    end
    p.ine
end
function getext(p::Polyhedron)
    if p.ext === nothing
        p.ext = copygenerators(getpoly(p))
    end
    p.ext
end
function getpoly(p::Polyhedron, inepriority=true)
    if p.poly === nothing
        if !inepriority && p.ext !== nothing
            p.poly = CDDPolyhedra(p.ext)
        elseif p.ine !== nothing
            p.poly = CDDPolyhedra(p.ine)
        elseif p.ext !== nothing
            p.poly = CDDPolyhedra(p.ext)
        else
            error("Please report this bug")
        end
    end
    p.poly
end
function gethincidence(p::Polyhedron)
    inc = p.hincidence
    if inc === nothing
        poly = getpoly(p)
        nh = nhreps(getine(p))
        inc = poly.inequality ? copyincidence(poly) : copyinputincidence(poly)
        # See https://github.com/JuliaPolyhedra/CDDLib.jl/pull/101#issuecomment-3830990456
        if (getext(p)).cone
            push!(inc, BitSet(1:nh))  # Add incidence for the origin
        else
            for bs in inc
                delete!(bs, nh+1)  # Remove the extra hyperplane
            end
        end
        p.hincidence = inc
    end
    return inc
end
function getvincidence(p::Polyhedron)
    inc = p.vincidence
    if inc === nothing
        poly = getpoly(p)
        nv = nvreps(getext(p))
        inc = poly.inequality ? copyinputincidence(poly) : copyincidence(poly)
        # See https://github.com/JuliaPolyhedra/CDDLib.jl/pull/101#issuecomment-3830990456
        if (getext(p)).cone
            for bs in inc
                push!(bs, nv)  # Add the origin
            end
        else
            nh = nhreps(getine(p))
            length(inc) == nh || pop!(inc)  # Remove the incidence of the extra hyperplane
        end
        p.vincidence = inc
    end
    return inc
end

function clearfield!(p::Polyhedron)
    p.ine = nothing
    p.ext = nothing
    p.poly = nothing
    p.hincidence = nothing
    p.vincidence = nothing
    p.hlinearitydetected = false
    p.vlinearitydetected = false
    p.noredundantinequality = false
    p.noredundantgenerator = false
end
function updateine!(p::Polyhedron, ine::CDDInequalityMatrix)
    clearfield!(p)
    p.ine = ine
end
function updateext!(p::Polyhedron, ext::CDDGeneratorMatrix)
    clearfield!(p)
    p.ext = ext
end
function updatepoly!(p::Polyhedron, poly::CDDPolyhedra)
    clearfield!(p)
    p.poly = poly
end
function clearpoly!(p::Polyhedron)
    p.hincidence = nothing
    p.vincidence = nothing
    p.poly = nothing
end

function Base.copy(p::Polyhedron{T}) where {T}
    pcopy = nothing
    if p.ine !== nothing
        pcopy = Polyhedron{T}(copy(p.ine))
    end
    if p.ext !== nothing
        if pcopy === nothing
            pcopy = Polyhedron{T}(copy(p.ext))
        else
            pcopy.ext = copy(p.ext)
        end
    end
    if pcopy === nothing
        # copy of ine and ext may be not necessary here
        # but I do it to be sure
        pcopy = Polyhedron{T}(copy(getine(p)))
        pcopy.ext = copy(getext(p))
    end
    pcopy.hlinearitydetected     = p.hlinearitydetected
    pcopy.vlinearitydetected     = p.vlinearitydetected
    pcopy.noredundantinequality = p.noredundantinequality
    pcopy.noredundantgenerator  = p.noredundantgenerator
    pcopy
end

# Implementation of Polyhedron's mandatory interface
function polytypeforprecision(precision::Symbol)
    if !(precision in (:float, :exact))
        error("precision should be :float or :exact, you gave $precision")
    end
    precision == :float ? Cdouble : Rational{BigInt}
end

function Polyhedra.polyhedron(rep::Representation, lib::Library)
    T = polytypeforprecision(lib.precision)
    convert(Polyhedron{T}, rep)
end
function Polyhedra.polyhedron(hyperplanes::Polyhedra.HyperPlaneIt, halfspaces::Polyhedra.HalfSpaceIt, lib::Library)
    T = polytypeforprecision(lib.precision)
    Polyhedron{T}(hyperplanes, halfspaces)
end
function Polyhedra.polyhedron(points::Polyhedra.PointIt, lines::Polyhedra.LineIt, rays::Polyhedra.RayIt, lib::Library)
    T = polytypeforprecision(lib.precision)
    Polyhedron{T}(points, lines, rays)
end

# need to specify to avoid ambiguïty
Base.convert(::Type{Polyhedron{T}}, rep::HRepresentation) where {T} = Polyhedron{T}(cddmatrix(T, rep))
Base.convert(::Type{Polyhedron{T}}, rep::VRepresentation) where {T} = Polyhedron{T}(cddmatrix(T, rep))

Polyhedron{T}(d::Polyhedra.FullDim, hits::Polyhedra.HIt{T}...) where {T} = Polyhedron{T}(CDDInequalityMatrix{T, mytype(T)}(d, hits...))
Polyhedron{T}(d::Polyhedra.FullDim, vits::Polyhedra.VIt{T}...) where {T} = Polyhedron{T}(CDDGeneratorMatrix{T, mytype(T)}(d, vits...))

function Polyhedra.hrepiscomputed(p::Polyhedron)
    p.ine !== nothing
end
function Polyhedra.hrep(p::Polyhedron{T}) where {T}
    getine(p)
end

function Polyhedra.vrepiscomputed(p::Polyhedron)
    p.ext !== nothing
end
function Polyhedra.vrep(p::Polyhedron{T}) where {T}
    getext(p)
end


Polyhedra.supportselimination(p::Polyhedron, ::FourierMotzkin) = true
function Polyhedra.eliminate(p::Polyhedron{T}, delset, ::FourierMotzkin) where {T}
    if iszero(length(delset))
        p
    else
        ine = getine(p)
        ds = collect(delset)
        for i in length(ds):-1:1
            if ds[i] != fulldim(ine)
                error("The CDD implementation of Fourier-Motzkin only support removing the last dimensions")
            end
            ine = fourierelimination(ine)
        end
        Polyhedron{T}(ine)
    end
end
Polyhedra.supportselimination(p::Polyhedron, ::BlockElimination) = true
function Polyhedra.eliminate(p::Polyhedron{T}, delset, ::BlockElimination) where {T}
    if iszero(length(delset))
        p
    else
        Polyhedron{T}(blockelimination(getine(p), delset))
    end
end

function Polyhedra.eliminate(p::Polyhedron, delset, method::DefaultElimination)
    if iszero(length(delset))
        eliminate(p, delset, FourierMotzkin())
    else
        fourier = false
        if length(delset) == 1 && fulldim(p) in delset
            # CDD's implementation of Fourier-Motzkin does not support linearity
            canonicalizelinearity!(getine(p))
            if iszero(nhyperplanes(p))
                fourier = true
            end
        end
        eliminate(p, delset, fourier ? FourierMotzkin() : BlockElimination())
    end
end

# FIXME `hchebyshevcenter` needs a floating point solver so it may give
# `Optimizer{Cdouble}` here for `Polyhedron{Rational{BigInt}}` but we are just
# going to use `Optimizer{Rational{BigInt}}` instead.
function Polyhedra.detecthlinearity!(p::Polyhedron{T}, solver::Type{<:Optimizer}=Optimizer{T}; kws...) where T
    if !p.hlinearitydetected
        canonicalizelinearity!(getine(p))
        p.hlinearitydetected = true
        # getine(p.poly) would return bad inequalities.
        # If someone use the poly then ine will be invalidated
        # and if he asks the inequalities he will be surprised that the
        # linearity are not detected properly
        # However, the generators can be kept
        clearpoly!(p)
    end
end
function Polyhedra.detectvlinearity!(p::Polyhedron{T}, solver::Type{<:Optimizer}=Optimizer{T}; kws...) where T
    if !p.vlinearitydetected
        canonicalizelinearity!(getext(p))
        p.vlinearitydetected = true
        # getext(p.poly) would return bad inequalities.
        # If someone use the poly then ext will be invalidated
        # and if he asks the generators he will be surprised that the
        # linearity are not detected properly
        # However, the inequalities can be kept
        clearpoly!(p)
    end
end


function Polyhedra.removehredundancy!(p::Polyhedron; kws...)
    if !p.noredundantinequality
        if !p.hlinearitydetected
            canonicalize!(getine(p))
            p.hlinearitydetected = true
        else
            redundancyremove!(getine(p))
        end
        p.noredundantinequality = true
        # See detectlinearity! for a discussion about the following line
        clearpoly!(p)
    end
end

function Polyhedra.removevredundancy!(p::Polyhedron; kws...)
    if !p.noredundantgenerator
        canonicalize!(getext(p))
        p.noredundantgenerator = true
        # See detecthlinearity! for a discussion about the following line
        clearpoly!(p)
    end
end

Base.intersect!(p::Polyhedron, h::HRepElement) = intersect!(p, intersect(h))
function Base.intersect!(p::Polyhedron, ine::HRepresentation)
    updateine!(p, matrixappend(getine(p), ine))
    #push!(getpoly(p, true), ine) # too slow because it computes double description
    #updatepoly!(p, getpoly(p)) # invalidate others
end
Polyhedra.convexhull!(p::Polyhedron, v::VRepElement) = convexhull!(p, convexhull(v))
function Polyhedra.convexhull!(p::Polyhedron, ext::VRepresentation)
    updateext!(p, matrixappend(getext(p), ext))
    #push!(getpoly(p, false), ext) # too slow because it computes double description
    #updatepoly!(p, getpoly(p)) # invalidate others
end

function Polyhedra.default_solver(p::Polyhedron{S}; T=S) where {S}
    return Optimizer{T}
end
_getrepfor(p::Polyhedron, ::Polyhedra.HIndex) = getine(p)
_getrepfor(p::Polyhedron, ::Polyhedra.VIndex) = getext(p)
function Polyhedra.isredundant(p::Polyhedron, idx::Polyhedra.Index; strongly=false, cert=false, solver=nothing)
    f = strongly ? sredundant : redundant
    ans = f(_getrepfor(p, idx), idx.value)
    if cert
        ans
    else
        ans[1]
    end
end

# Implementation of Polyhedron's optional interface
# TODO use the following once OptimizerFactory is typed
#function Base.isempty(p::Polyhedron{T}, solver::JuMP.OptimizerFactory{typeof(Optimizer{T})}) where T
function Base.isempty(p::Polyhedron)
    lp = matrix2feasibility(getine(p))
    lpsolve(lp)
    # It is impossible to be unbounded since there is no objective
    # Note that `status` would also work
    return MOI.get(copylpsolution(lp), MOI.TerminationStatus()) != MOI.OPTIMAL
end

function gethredundantindices(p::Polyhedron; kws...)
    redundantrows(getine(p); kws...)
end
function getvredundantindices(p::Polyhedron; kws...)
    redundantrows(getext(p); kws...)
end

# type CDDLPPolyhedron{T} <: LPPolyhedron{T}
#   ine::CDDInequalityMatrix
#   has_objective::Bool
#
#   objval
#   solution
#   status
# end
#
# function LinearQuadraticModel{T}(p::Polyhedron{T})
#   CDDLPPolyhedron{T}(getine(p), false, nothing, nothing, nothing)
# end
# function loadproblem!(lpm::CDDLPPolyhedron, obj, sense)
#   if sum(abs(obj)) != 0
#     setobjective(lpm.ine, obj, sense)
#     lpm.has_objective = true
#   end
# end
# function optimize!(lpm::CDDLPPolyhedron)
#   if lpm.has_objective
#     lp = matrix2lp(lpm.ine)
#   else
#     lp = matrix2feasibility(lpm.ine)
#   end
#   lpsolve(lp)
#   sol = copylpsolution(lp)
#   lpm.status = simplestatus(sol)
#   # We have just called lpsolve so it shouldn't be Undecided
#   # if no error occured
#   lpm.status == :Undecided && (lpm.status = :Error)
#   lpm.objval = getobjval(sol)
#   lpm.solution = getsolution(sol)
# end
#
# function status(lpm::CDDLPPolyhedron)
#   lpm.status
# end
# function getobjval(lpm::CDDLPPolyhedron)
#   lpm.objval
# end
# function getsolution(lpm::CDDLPPolyhedron)
#   copy(lpm.solution)
# end
# function getunboundedray(lpm::CDDLPPolyhedron)
#   copy(lpm.solution)
# end

function dd_inputappend(poly::Ptr{Cdd_PolyhedraData{Cdouble}}, matrix::Ptr{Cdd_MatrixData{Cdouble}})
    polyptr = Ref{Ptr{Cdd_PolyhedraData{Cdouble}}}(poly)
    found = @ddf_ccall_error(
        DDInputAppend,
        Cdd_boolean,
        (Ref{Ptr{Cdd_PolyhedraData{Cdouble}}}, Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
        polyptr,
        matrix,
    )
    if !Bool(found)
        println("Double description not found")
    end
    polyptr[]
end

function dd_inputappend(poly::Ptr{Cdd_PolyhedraData{GMPRational}}, matrix::Ptr{Cdd_MatrixData{GMPRational}})
    polyptr = Ref{Ptr{Cdd_PolyhedraData{GMPRational}}}(poly)
    found = @dd_ccall_error(
        DDInputAppend,
        Cdd_boolean,
        (Ref{Ptr{Cdd_PolyhedraData{GMPRational}}}, Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
        polyptr,
        matrix,
    )
    if !Bool(found)
        println("Double description not found") # FIXME
    end
    polyptr[]
end

function Base.push!(poly::CDDPolyhedra{T}, ine::CDDInequalityMatrix{T}) where {T<:PolyType}
    if !poly.inequality
        switchinputtype!(poly)
    end
    poly.poly = dd_inputappend(poly.poly, ine.matrix)
end

function Base.push!(poly::CDDPolyhedra{T}, ext::CDDGeneratorMatrix{T}) where {T<:PolyType}
    if poly.inequality
        switchinputtype!(poly)
    end
    poly.poly = dd_inputappend(poly.poly, ext.matrix)
end

function Base.push!(poly::CDDPolyhedra{T}, rep::Representation{S}) where {T,S}
    Base.push!(poly, cddmatrix(T, rep))
end

function dd_matrixappend(matrix1::Ptr{Cdd_MatrixData{Cdouble}}, matrix2::Ptr{Cdd_MatrixData{Cdouble}})
    @ddf_ccall MatrixAppend Ptr{Cdd_MatrixData{Cdouble}} (Ptr{Cdd_MatrixData{Cdouble}}, Ptr{Cdd_MatrixData{Cdouble}}) matrix1 matrix2
end
function dd_matrixappend(matrix1::Ptr{Cdd_MatrixData{GMPRational}}, matrix2::Ptr{Cdd_MatrixData{GMPRational}})
    @dd_ccall MatrixAppend Ptr{Cdd_MatrixData{GMPRational}} (Ptr{Cdd_MatrixData{GMPRational}}, Ptr{Cdd_MatrixData{GMPRational}}) matrix1 matrix2
end
function matrixappend(matrix1::CDDInequalityMatrix{T, S}, matrix2::CDDInequalityMatrix{T, S}) where {T, S}
    CDDInequalityMatrix{T, S}(dd_matrixappend(matrix1.matrix, matrix2.matrix))
end
function matrixappend(matrix1::CDDGeneratorMatrix{T, S}, matrix2::CDDGeneratorMatrix{T, S}) where {T, S}
    CDDGeneratorMatrix{T, S}(dd_matrixappend(matrix1.matrix, matrix2.matrix))
end
function matrixappend(matrix::CDDMatrix{T}, repr::Representation{S}) where {S, T}
    matrixappend(matrix, cddmatrix(T, repr))
end

function dd_matrix2adjacency(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    return @ddf_ccall_pointer_error(
        Matrix2Adjacency,
        Ptr{SetFamily},
        (Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end

function dd_matrix2adjacency(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    return @dd_ccall_pointer_error(
        Matrix2Adjacency,
        Ptr{SetFamily},
        (Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end

# Note that this to computes the adjacency of input without doing representation conversion.
# If representation conversion was done, the adjacency and incidence of both input and output
# are in the `dd_PolyhedraPtr` data structure.
# https://github.com/JuliaPolyhedra/CDDLib.jl/issues/71#issuecomment-1166257174
function matrix2adjacency(matrix::CDDMatrix)
    return convert_free(Vector{BitSet}, dd_matrix2adjacency(matrix.matrix))
end

# Redundant
function dd_redundant(matrix::Ptr{Cdd_MatrixData{Cdouble}}, i::Cdd_rowrange, len::Int)
    certificate = Vector{Cdouble}(undef, len)
    found = @ddf_ccall_error(
        Redundant,
        Cdd_boolean,
        (Ptr{Cdd_MatrixData{Cdouble}}, Cdd_rowrange, Ptr{Cdouble}, Ref{Cdd_ErrorType}),
        matrix,
        i,
        certificate,
    )
    (found, certificate)
end
function dd_redundant(matrix::Ptr{Cdd_MatrixData{GMPRational}}, i::Cdd_rowrange, len::Int)
    certificateGMPRat = zeros(GMPRational, len)
    found = @dd_ccall_error(
        Redundant,
        Cdd_boolean,
        (Ptr{Cdd_MatrixData{GMPRational}}, Cdd_rowrange, Ptr{GMPRational}, Ref{Cdd_ErrorType}),
        matrix,
        i,
        certificateGMPRat,
    )
    certificate = Array{Rational{BigInt}}(certificateGMPRat)
    # myfree(certificateGMPRat)  # disabled due to https://github.com/JuliaPolyhedra/CDDLib.jl/issues/13
    (found, certificate)
end
function redundant(matrix::CDDMatrix, i::Integer)
    if dd_set_member(unsafe_load(matrix.matrix).linset, i)
        error("Redundancy check for equality not supported")
    end
    (found, certificate) = dd_redundant(matrix.matrix, Cdd_rowrange(i), fulldim(matrix)+1)
    # FIXME what is the meaning of the first element of the certificate ?
    (Bool(found), certificate[2:end])
end
function redundant(repr::Representation, i::Integer)
    redundant(CDDMatrix(repr), i)
end

# Redundant rows
function dd_redundantrows(matrix::Ptr{Cdd_MatrixData{Cdouble}}; via_shooting::Bool = false)
    if via_shooting
        return @ddf_ccall_pointer_error(
            RedundantRowsViaShooting,
            Ptr{Culong},
            (Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
            matrix,
        )
    else
        return @ddf_ccall_pointer_error(
            RedundantRows,
            Ptr{Culong},
            (Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
            matrix,
        )
    end
end

function dd_redundantrows(matrix::Ptr{Cdd_MatrixData{GMPRational}}; via_shooting::Bool = false)
    if via_shooting
        return @dd_ccall_pointer_error(
            RedundantRowsViaShooting,
            Ptr{Culong},
            (Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
            matrix,
        )
    else
        return @dd_ccall_pointer_error(
            RedundantRows,
            Ptr{Culong},
            (Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
            matrix,
        )
    end
end

function redundantrows(matrix::CDDMatrix; kws...)
    convert_free(BitSet, CDDSet(dd_redundantrows(matrix.matrix; kws...), length(matrix)))
end

function redundantrows(repr::Representation; kws...)
    redundantrows(CDDMatrix(repr); kws...)
end

# Strongly redundant
function dd_sredundant(matrix::Ptr{Cdd_MatrixData{Cdouble}}, i::Cdd_rowrange, len::Int)
    certificate = Vector{Cdouble1}(undef, len)
    found = @ddf_ccall_error(
        SRedundant,
        Cdd_boolean,
        (Ptr{Cdd_MatrixData{Cdouble}}, Cdd_rowrange, Ptr{Cdouble}, Ref{Cdd_ErrorType}),
        matrix,
        i,
        certificate,
    )
    (found, certificate)
end
function dd_sredundant(matrix::Ptr{Cdd_MatrixData{GMPRational}}, i::Cdd_rowrange, len::Int)
    certificateGMPRat = zeros(GMPRational, len)
    found = @dd_ccall_error(
        SRedundant,
        Cdd_boolean,
        (Ptr{Cdd_MatrixData{GMPRational}}, Cdd_rowrange, Ptr{GMPRational}, Ref{Cdd_ErrorType}),
        matrix,
        i,
        certificateGMPRat,
    )
    certificate = Array{Rational{BigInt}}(certificateGMPRat)
    # myfree(certificateGMPRat)  # disabled due to https://github.com/JuliaPolyhedra/CDDLib.jl/issues/13
    (found, certificate)
end
function sredundant(matrix::CDDMatrix, i::Integer)
    if dd_set_member(unsafe_load(matrix.matrix).linset, i)
        error("Redundancy check for equality not supported")
    end
    (found, certificate) = dd_sredundant(matrix.matrix, Cdd_rowrange(i), fulldim(matrix)+1)
    # FIXME what is the meaning of the first element of the certificate ? 1 for point, 0 for ray ?
    (Bool(found), certificate[2:end])
end
function sredundant(repr::Representation, i::Integer)
    sredundant(CDDMatrix(repr), i)
end

function dd_matrixcanonicalize(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    matptr = Ref{Ptr{Cdd_MatrixData{Cdouble}}}(matrix)
    impl_linset = Ref{Cdd_rowset}(0)
    redset = Ref{Cdd_rowset}(0)
    newpos = Ref{Cdd_rowindex}(0)
    found = @ddf_ccall_error(
        MatrixCanonicalize,
        Cdd_boolean,
        (Ref{Ptr{Cdd_MatrixData{Cdouble}}}, Ref{Cdd_rowset}, Ref{Cdd_rowset}, Ref{Cdd_rowindex}, Ref{Cdd_ErrorType}),
        matptr,
        impl_linset,
        redset,
        newpos,
    )
    (found, matptr[], impl_linset[], redset[], newpos[])
end
function dd_matrixcanonicalize(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    matptr = Ref{Ptr{Cdd_MatrixData{GMPRational}}}(matrix)
    impl_linset = Ref{Cdd_rowset}(0)
    redset = Ref{Cdd_rowset}(0)
    newpos = Ref{Cdd_rowindex}(0)
    found = @dd_ccall_error(
        MatrixCanonicalize,
        Cdd_boolean,
        (Ref{Ptr{Cdd_MatrixData{GMPRational}}}, Ref{Cdd_rowset}, Ref{Cdd_rowset}, Ref{Cdd_rowindex}, Ref{Cdd_ErrorType}),
        matptr,
        impl_linset,
        redset,
        newpos,
    )
    (found, matptr[], impl_linset[], redset[], newpos[])
end
function canonicalize!(matrix::CDDMatrix)
    iszero(length(matrix)) && return # See https://github.com/JuliaPolyhedra/CDDLib.jl/issues/24
    (found, matrix.matrix, impl_linset, redset, newpos) = dd_matrixcanonicalize(matrix.matrix)
    if !Bool(found)
        error("Canonicalization not found")
    end
    (impl_linset, redset, newpos) # TODO transform and free
end

function dd_matrixcanonicalizelinearity(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    matptr = Ref{Ptr{Cdd_MatrixData{Cdouble}}}(matrix)
    impl_linset = Ref{Cdd_rowset}(0)
    redset = Ref{Cdd_rowset}(0)
    newpos = Ref{Cdd_rowindex}(0)
    found = @ddf_ccall_error(
        MatrixCanonicalizeLinearity,
        Cdd_boolean,
        (Ref{Ptr{Cdd_MatrixData{Cdouble}}}, Ref{Cdd_rowset}, Ref{Cdd_rowindex}, Ref{Cdd_ErrorType}),
        matptr,
        impl_linset,
        newpos,
    )
    (found, matptr[], impl_linset[], newpos[])
end
function dd_matrixcanonicalizelinearity(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    matptr = Ref{Ptr{Cdd_MatrixData{GMPRational}}}(matrix)
    impl_linset = Ref{Cdd_rowset}(0)
    redset = Ref{Cdd_rowset}(0)
    newpos = Ref{Cdd_rowindex}(0)
    found = @dd_ccall_error(
        MatrixCanonicalizeLinearity,
        Cdd_boolean,
        (Ref{Ptr{Cdd_MatrixData{GMPRational}}}, Ref{Cdd_rowset}, Ref{Cdd_rowindex}, Ref{Cdd_ErrorType}),
        matptr,
        impl_linset,
        newpos,
    )
    (found, matptr[], impl_linset[], newpos[])
end
function canonicalizelinearity!(matrix::CDDMatrix)
    (found, matrix.matrix, impl_linset, newpos) = dd_matrixcanonicalizelinearity(matrix.matrix)
    if !Bool(found)
        error("Linearity canonicalization not found")
    end
    (impl_linset, newpos) # TODO transform and free
end

function dd_matrixredundancyremove(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    matptr = Ref{Ptr{Cdd_MatrixData{Cdouble}}}(matrix)
    redset = Ref{Cdd_rowset}(0)
    newpos = Ref{Cdd_rowindex}(0)
    found = @ddf_ccall_error(
        MatrixRedundancyRemove,
        Cdd_boolean,
        (Ref{Ptr{Cdd_MatrixData{Cdouble}}}, Ref{Cdd_rowset}, Ref{Cdd_rowindex}, Ref{Cdd_ErrorType}),
        matptr,
        redset,
        newpos,
    )
    (found, matptr[], redset[], newpos[])
end
function dd_matrixredundancyremove(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    matptr = Ref{Ptr{Cdd_MatrixData{GMPRational}}}(matrix)
    redset = Ref{Cdd_rowset}(0)
    newpos = Ref{Cdd_rowindex}(0)
    found = @dd_ccall_error(
        MatrixRedundancyRemove,
        Cdd_boolean,
        (Ref{Ptr{Cdd_MatrixData{GMPRational}}}, Ref{Cdd_rowset}, Ref{Cdd_rowindex}, Ref{Cdd_ErrorType}),
        matptr,
        redset,
        newpos,
    )
    (found, matptr[], redset[], newpos[])
end
function redundancyremove!(matrix::CDDMatrix)
    (found, matrix.matrix, redset, newpos) = dd_matrixredundancyremove(matrix.matrix)
    if !Bool(found)
        error("Redundancy removal not found")
    end
    (redset, newpos) # TODO transform and free
end

# Fourier Elimination

function dd_fourierelimination(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    return @ddf_ccall_pointer_error(
        FourierElimination,
        Ptr{Cdd_MatrixData{Cdouble}},
        (Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end
function dd_fourierelimination(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    return @dd_ccall_pointer_error(
        FourierElimination,
        Ptr{Cdd_MatrixData{GMPRational}},
        (Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
        matrix,
    )
    newmatrix
end
function fourierelimination(matrix::CDDInequalityMatrix{T, S}) where {T, S}
    CDDInequalityMatrix{T, S}(dd_fourierelimination(matrix.matrix))
end
function fourierelimination(ine::HRepresentation)
    fourierelimination(CDDInequalityMatrix(ine))
end

# Block Elimination

function dd_blockelimination(matrix::Ptr{Cdd_MatrixData{Cdouble}}, delset::Cdd_colset)
    return @ddf_ccall_pointer_error(
        BlockElimination,
        Ptr{Cdd_MatrixData{Cdouble}},
        (Ptr{Cdd_MatrixData{Cdouble}}, Cdd_colset, Ref{Cdd_ErrorType}),
        matrix,
        delset,
    )
end
function dd_blockelimination(matrix::Ptr{Cdd_MatrixData{GMPRational}}, delset::Cdd_colset)
    return @dd_ccall_pointer_error(
        BlockElimination,
        Ptr{Cdd_MatrixData{GMPRational}},
        (Ptr{Cdd_MatrixData{GMPRational}}, Cdd_colset, Ref{Cdd_ErrorType}),
        matrix,
        delset,
    )
end
function blockelimination(matrix::CDDInequalityMatrix{T, S}, delset=BitSet([fulldim(matrix)])) where {T, S}
    if last(delset) > fulldim(matrix)
        error("Invalid variable to eliminate")
    end
    # offset of 1 because 1 is for the first column of the matrix
    # (indicating the linearity) so 2 is the first dimension
    CDDInequalityMatrix{T, S}(dd_blockelimination(matrix.matrix, CDDSet(delset, fulldim(matrix)+1, 1).s))
end
function blockelimination(ine::HRepresentation, delset=BitSet([fulldim(ine)]))
    blockelimination(Base.convert(CDDInequalityMatrix, ine), delset)
end

export redundant, redundantrows, sredundant, matrix2adjacency, fourierelimination, blockelimination, canonicalize!, redundancyremove!

using SparseArrays

import MathOptInterface as MOI

"""
    CDDLib.Optimizer{T} <: AbstractPolyhedraOptimizer{T}

CDDLib Linear Programming solver, supports either exact arithmetic or floating point arithmetic.
"""
mutable struct Optimizer{T} <: Polyhedra.AbstractPolyhedraOptimizer{T}
    solver_type::Symbol
    lphrep::LPHRep{T}
    # Feasible set defined by user
    rep::Union{Rep{T}, Nothing}
    # Either `rep` or `polyhedron(lphrep, library)`.
    # It is kept between consecutive solve if not modified,
    # e.g. if only the objective is changed.
    feasible_set::Union{Rep{T}, Nothing}

    objective_sense::MOI.OptimizationSense
    objective_func::Union{SparseVector{T, Int64}, Nothing}
    objective_constant::T

    sol::Union{Nothing, CDDLPSolution} # TODO {S} where S = mytype(T)
    solution::Union{AbstractVector{T}, Nothing}

    function Optimizer{T}(solver_type::Symbol = :DualSimplex) where T
        if !(solver_type in [:CrissCross, :DualSimplex])
            error("Invalid solver type `$solver_type`, it should be `:CrissCross` or `:DualSimplex`.")
        end
        new(solver_type, LPHRep(Polyhedra._MOIModel{T}()), nothing, nothing,
            MOI.FEASIBILITY_SENSE, nothing, zero(T),
            nothing, nothing)
    end
end

Polyhedra.coefficient_type(::Optimizer{T}) where {T} = T
MOI.get(::Optimizer, ::MOI.SolverName) = "CDD"

function MOI.empty!(lpm::Optimizer{T}) where T
    lpm.lphrep = LPHRep(Polyhedra._MOIModel{T}())
    lpm.rep = nothing
    lpm.feasible_set = nothing
    lpm.objective_sense = MOI.FEASIBILITY_SENSE
    lpm.objective_func = nothing
    lpm.objective_constant = zero(T)
    lpm.sol = nothing
    lpm.solution = nothing
end
function MOI.is_empty(lpm::Optimizer{T}) where T
    MOI.is_empty(lpm.lphrep.model) &&
    lpm.rep === nothing &&
    lpm.feasible_set === nothing &&
    lpm.objective_sense == MOI.FEASIBILITY_SENSE &&
    lpm.objective_func === nothing &&
    iszero(lpm.objective_constant) &&
    lpm.sol === nothing &&
    lpm.solution === nothing
end


function MOI.optimize!(lpm::Optimizer{T}) where T
    if lpm.rep === nothing
        lpm.feasible_set = lpm.lphrep
    else
        if hasallhalfspaces(lpm.lphrep)
            error("Cannot provide both a polyhedral feasible set and additional constraints.")
        end
        lpm.feasible_set = lpm.rep
    end
    prob = convert(CDDInequalityMatrix{T, mytype(T)}, lpm.feasible_set)
    if lpm.objective_sense == MOI.FEASIBILITY_SENSE
        # Otherwise CDD throws the error "No LP objective"
        setobjective(prob, zeros(T, fulldim(lpm.feasible_set)), true)
    else
        @assert lpm.objective_func !== nothing
        setobjective(prob, lpm.objective_func, lpm.objective_sense == MOI.MAX_SENSE)
    end
    lp = matrix2lp(prob)
    lpsolve(lp, lpm.solver_type)
    lpm.sol = copylpsolution(lp)
    lpm.solution = getsolution(lpm.sol)

    # FIXME if A is GMPRational, check that no creation/leak

    # A and b free'd by ine
end

function MOI.get(sol::CDDLPSolution, ::MOI.RawStatusString)
    ["Undecided", "Optimal", "Inconsistent",
     "Dual inconsistent", "Struct inconsistent", "Struct dual inconsistent",
     "Unbounded", "Dual unbounded"][unsafe_load(sol.sol).LPS+1]
end
function MOI.get(sol::CDDLPSolution, ::MOI.TerminationStatus)
    [MOI.OPTIMIZE_NOT_CALLED, MOI.OPTIMAL, MOI.INFEASIBLE,
     MOI.DUAL_INFEASIBLE, MOI.INFEASIBLE, MOI.DUAL_INFEASIBLE,
     MOI.DUAL_INFEASIBLE, MOI.INFEASIBLE][unsafe_load(sol.sol).LPS+1]
end
function MOI.get(sol::CDDLPSolution{GMPRational}, ::MOI.ObjectiveValue)
    convert(Rational{Int}, unsafe_load(sol.sol).optvalue)
end
function MOI.get(lpm::Optimizer,
                 attr::Union{MOI.RawStatusString,
                             MOI.TerminationStatus})
    if lpm.sol === nothing
        return MOI.OPTIMIZE_NOT_CALLED
    else
        return MOI.get(lpm.sol, attr)
    end
end

function MOI.get(sol::CDDLPSolution{Cdouble}, ::MOI.ObjectiveValue)
    unsafe_load(sol.sol).optvalue
end
function MOI.get(lpm::Optimizer, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(lpm, attr)
    return MOI.get(lpm.sol, attr) + lpm.objective_constant
end

function MOI.get(lpm::Optimizer, ::MOI.ResultCount)
    status = MOI.get(lpm, MOI.TerminationStatus())
    if status == MOI.OPTIMAL || status == MOI.DUAL_INFEASIBLE
        return 1
    else
        return 0
    end
end

function MOI.get(lpm::Optimizer, attr::MOI.PrimalStatus)
    if attr.result_index > MOI.get(lpm, MOI.ResultCount())
        return MOI.NO_SOLUTION
    end
    term = MOI.get(lpm, MOI.TerminationStatus())
    if term == MOI.OPTIMAL
        return MOI.FEASIBLE_POINT
    elseif term == MOI.DUAL_INFEASIBLE
        return MOI.INFEASIBILITY_CERTIFICATE
    else
        return MOI.NO_SOLUTION
    end
end
function MOI.get(lpm::Optimizer, attr::MOI.VariablePrimal, vi::MOI.VariableIndex)
    MOI.check_result_index_bounds(lpm, attr)
    return lpm.solution[vi.value]
end
function MOI.get(lpm::Optimizer{T}, attr::MOI.ConstraintPrimal,
                 ci::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},
                                         <:Union{MOI.EqualTo{T},
                                                 MOI.LessThan{T}}}) where T
    # TODO remove once https://github.com/jump-dev/MathOptInterface.jl/pull/1684 is merged
    MOI.check_result_index_bounds(lpm, attr)
    return MOI.Utilities.get_fallback(lpm, attr, ci)
end

# TODO dual
MOI.get(::Optimizer, ::MOI.DualStatus) = MOI.NO_SOLUTION

mutable struct Cdd_PolyhedraData{T<:MyType}
    representation::Cdd_RepresentationType
    # given representation
    homogeneous::Cdd_boolean
    d::Cdd_colrange
    m::Cdd_rowrange
    A::Cdd_Amatrix{T}
    # Inequality System:  m times d matrix
    numbtype::Cdd_NumberType
    child::Ptr{Nothing} # dd_ConePtr
    # pointing to the homogenized cone data
    m_alloc::Cdd_rowrange
    # allocated row size of matrix A
    d_alloc::Cdd_colrange
    # allocated col size of matrix A
    c::Cdd_Arow{T}
    # cost vector

    EqualityIndex::Cdd_rowflag
    # ith component is 1 if it is equality, -1 if it is strict inequality, 0 otherwise.

    IsEmpty::Cdd_boolean
    # This is to tell whether the set is empty or not

    NondegAssumed::Cdd_boolean
    InitBasisAtBottom::Cdd_boolean
    RestrictedEnumeration::Cdd_boolean
    RelaxedEnumeration::Cdd_boolean

    m1::Cdd_rowrange
    #    = m or m+1 (when representation=Inequality && !homogeneous)
    #    This data is written after dd_ConeDataLoad is called.  This
    #    determines the size of Ainc.
    AincGenerated::Cdd_boolean
    #    Indicates whether Ainc, Ared, Adom are all computed.
    #    All the variables below are valid only when this is TRUE
    ldim::Cdd_colrange
    # linearity dimension
    n::Cdd_bigrange
    #    the size of output = total number of rays
    #    in the computed cone + linearity dimension
    Ainc::Cdd_Aincidence
    #    incidence of input and output
    Ared::Cdd_rowset
    #    redundant set of rows whose removal results in a minimal system
    Adom::Cdd_rowset
    #    dominant set of rows (those containing all rays).
end

function dd_matrix2poly(matrix::Ptr{Cdd_MatrixData{Cdouble}})
    return @ddf_ccall_pointer_error(
        DDMatrix2Poly,
        Ptr{Cdd_PolyhedraData{Cdouble}},
        (Ptr{Cdd_MatrixData{Cdouble}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end
function dd_matrix2poly(matrix::Ptr{Cdd_MatrixData{GMPRational}})
    return @dd_ccall_pointer_error(
        DDMatrix2Poly,
        Ptr{Cdd_PolyhedraData{GMPRational}},
        (Ptr{Cdd_MatrixData{GMPRational}}, Ref{Cdd_ErrorType}),
        matrix,
    )
end

mutable struct CDDPolyhedra{T<:PolyType, S}
    poly::Ptr{Cdd_PolyhedraData{S}}
    inequality::Bool # The input type is inequality

    function CDDPolyhedra{T, S}(matrix::CDDMatrix{T}) where {T <: PolyType, S}
        polyptr = dd_matrix2poly(matrix.matrix)
        poly = new{T, S}(polyptr, isaninequalityrepresentation(matrix))
        finalizer(myfree, poly)
        poly
    end

end

function myfree(poly::CDDPolyhedra{Cdouble})
    @ddf_ccall FreePolyhedra Nothing (Ptr{Cdd_PolyhedraData{Cdouble}},) poly.poly
end
function myfree(poly::CDDPolyhedra{Rational{BigInt}})
    @dd_ccall FreePolyhedra Nothing (Ptr{Cdd_PolyhedraData{GMPRational}},) poly.poly
end

CDDPolyhedra(matrix::CDDMatrix{T, S}) where {T, S} = CDDPolyhedra{T, S}(matrix)
CDDPolyhedra(rep::Representation) = CDDPolyhedra(CDDMatrix(rep))

function Base.convert(::Type{CDDPolyhedra{T, S}}, matrix::CDDMatrix{T, S}) where {T, S}
    CDDPolyhedra{T, S}(matrix)
end
Base.convert(::Type{CDDPolyhedra{T, S}}, repr::Representation{T}) where {T, S} = CDDPolyhedra(CDDMatrix(repr))

function dd_copyinequalities(poly::Ptr{Cdd_PolyhedraData{Cdouble}})
    @ddf_ccall CopyInequalities Ptr{Cdd_MatrixData{Cdouble}} (Ptr{Cdd_PolyhedraData{Cdouble}},) poly
end
function dd_copyinequalities(poly::Ptr{Cdd_PolyhedraData{GMPRational}})
    @dd_ccall CopyInequalities Ptr{Cdd_MatrixData{GMPRational}} (Ptr{Cdd_PolyhedraData{GMPRational}},) poly
end
function copyinequalities(poly::CDDPolyhedra)
    CDDInequalityMatrix(dd_copyinequalities(poly.poly))
end

function dd_copygenerators(poly::Ptr{Cdd_PolyhedraData{Cdouble}})
    @ddf_ccall CopyGenerators Ptr{Cdd_MatrixData{Cdouble}} (Ptr{Cdd_PolyhedraData{Cdouble}},) poly
end
function dd_copygenerators(poly::Ptr{Cdd_PolyhedraData{GMPRational}})
    @dd_ccall CopyGenerators Ptr{Cdd_MatrixData{GMPRational}} (Ptr{Cdd_PolyhedraData{GMPRational}},) poly
end

function copygenerators(poly::CDDPolyhedra)
    CDDGeneratorMatrix(dd_copygenerators(poly.poly))
end

# Incidence information
for c_fun in (:CopyIncidence, :CopyInputIncidence)
    jl_fun = Symbol(lowercase(String(c_fun)))
    dd_fun = Symbol(:dd_, jl_fun)

    @eval begin
        function $(dd_fun)(poly::Ptr{Cdd_PolyhedraData{Cdouble}})
            @ddf_ccall $c_fun Ptr{SetFamily} (Ptr{Cdd_PolyhedraData{Cdouble}},) poly
        end
        function $(dd_fun)(poly::Ptr{Cdd_PolyhedraData{GMPRational}})
            @dd_ccall $c_fun Ptr{SetFamily} (Ptr{Cdd_PolyhedraData{GMPRational}},) poly
        end

        function $(jl_fun)(poly::CDDPolyhedra)
            return convert_free(Vector{BitSet}, $(dd_fun)(poly.poly))
        end
    end
end

"""
    copyincidence(poly)

Return the incidence representation of the computed representation in `poly`.

# Arguments

- `poly::CDDPolyhedra`

# Returns

- `::Vector{BitSet}`

#Examples

```julia
julia> using CDDLib, Polyhedra

julia> A = [1 1; 1 -1; -1 0]; b = [1, 0, 0];

julia> p = polyhedron(hrep(A, b), CDDLib.Library(:exact))
Polyhedron CDDLib.Polyhedron{Rational{BigInt}}:
3-element iterator of HalfSpace{Rational{BigInt}, Vector{Rational{BigInt}}}:
 HalfSpace(Rational{BigInt}[1, 1], 1//1)
 HalfSpace(Rational{BigInt}[1, -1], 0//1)
 HalfSpace(Rational{BigInt}[-1, 0], 0//1)

julia> vrep(p)
V-representation CDDGeneratorMatrix{Rational{BigInt}, GMPRational}:
3-element iterator of Vector{Rational{BigInt}}:
 Rational{BigInt}[1//2, 1//2]
 Rational{BigInt}[0, 1]
 Rational{BigInt}[0, 0]

julia> copyincidence(p.poly)
3-element Vector{BitSet}:
 BitSet([1, 2])
 BitSet([1, 3])
 BitSet([2, 3])
```

Degenerate case:

```julia
julia> A = [1 1; 1 -1; -1 0; 1 0]; b = [1, 0, 0, 1//2];

julia> p = polyhedron(hrep(A, b), CDDLib.Library(:exact))
Polyhedron CDDLib.Polyhedron{Rational{BigInt}}:
4-element iterator of HalfSpace{Rational{BigInt}, Vector{Rational{BigInt}}}:
 HalfSpace(Rational{BigInt}[1, 1], 1//1)
 HalfSpace(Rational{BigInt}[1, -1], 0//1)
 HalfSpace(Rational{BigInt}[-1, 0], 0//1)
 HalfSpace(Rational{BigInt}[1, 0], 1//2)

julia> vrep(p)
V-representation CDDGeneratorMatrix{Rational{BigInt}, GMPRational}:
3-element iterator of Vector{Rational{BigInt}}:
 Rational{BigInt}[0, 0]
 Rational{BigInt}[0, 1]
 Rational{BigInt}[1//2, 1//2]

julia> copyincidence(p.poly)
3-element Vector{BitSet}:
 BitSet([2, 3])
 BitSet([1, 3])
 BitSet([1, 2, 4])
```
"""
copyincidence

"""
    copyinputincidence(poly)

Return the incidence representation of the input representation in `poly`.

# Arguments

- `poly::CDDPolyhedra`

# Returns

- `::Vector{BitSet}`

#Examples

```julia
julia> using CDDLib, Polyhedra

julia> V = [[1//2, 1//2], [0, 1], [0, 0]];

julia> p = polyhedron(vrep(V), CDDLib.Library(:exact))
Polyhedron CDDLib.Polyhedron{Rational{BigInt}}:
3-element iterator of Vector{Rational{BigInt}}:
 Rational{BigInt}[1//2, 1//2]
 Rational{BigInt}[0, 1]
 Rational{BigInt}[0, 0]

julia> hrep(p)
H-representation CDDInequalityMatrix{Rational{BigInt}, GMPRational}:
3-element iterator of HalfSpace{Rational{BigInt}, Vector{Rational{BigInt}}}:
 HalfSpace(Rational{BigInt}[1, 1], 1//1)
 HalfSpace(Rational{BigInt}[-1, 0], 0//1)
 HalfSpace(Rational{BigInt}[1, -1], 0//1)

julia> copyinputincidence(p.poly)
3-element Vector{BitSet}:
 BitSet([1, 3])
 BitSet([1, 2])
 BitSet([2, 3])
```
"""
copyinputincidence

function switchinputtype!(poly::CDDPolyhedra)
    if poly.inequality
        ext = copygenerators(poly)
        myfree(poly)
        poly.poly = dd_matrix2poly(ext.matrix)
    else
        ine = copyinequalities(poly)
        myfree(poly)
        poly.poly = dd_matrix2poly(ine.matrix)
    end
    poly.inequality = ~poly.inequality
end

export CDDPolyhedra, copyinequalities, copygenerators, copyincidence, copyinputincidence, switchinputtype!

macro dd_ccall_pointer_error(f, args...)
    quote
        # RedundantRowsViaShooting don't modify the error code so
        # we need to set it with an initial value that means no error
        err = Ref{Cdd_ErrorType}(length(error_message))
        ptr = ccall(($"dd_$f", libcddgmp), $(map(esc,args)...), err)
        myerror($"dd_$f", ptr, err[])
        ptr
    end
end

macro dd_ccall_error(f, args...)
    quote
        # RedundantRowsViaShooting don't modify the error code so
        # we need to set it with an initial value that means no error
        err = Ref{Cdd_ErrorType}(length(error_message))
        ret = ccall(($"dd_$f", libcddgmp), $(map(esc,args)...), err)
        myerror($"dd_$f", err[])
        ret
    end
end

macro dd_ccall(f, args...)
    quote
        ret = ccall(($"dd_$f", libcddgmp), $(map(esc,args)...))
        ret
    end
end

macro ddf_ccall_pointer_error(f, args...)
    quote
        # RedundantRowsViaShooting don't modify the error code so
        # we need to set it with an initial value that means no error
        err = Ref{Cdd_ErrorType}(length(error_message))
        ptr = ccall(($"ddf_$f", libcddgmp), $(map(esc,args)...), err)
        myerror($"ddf_$f", ptr, err[])
        ptr
    end
end

macro ddf_ccall_error(f, args...)
    quote
        # RedundantRowsViaShooting don't modify the error code so
        # we need to set it with an initial value that means no error
        err = Ref{Cdd_ErrorType}(length(error_message))
        ret = ccall(($"ddf_$f", libcddgmp), $(map(esc,args)...), err)
        myerror($"ddf_$f", err[])
        ret
    end
end

macro ddf_ccall(f, args...)
    quote
        ret = ccall(($"ddf_$f", libcddgmp), $(map(esc,args)...))
        ret
    end
end


macro cdd_ccall(f, args...)
    quote
        ret = ccall(($"$f", libcddgmp), $(map(esc,args)...))
        ret
    end
end

@testset "Low-level simplex tests" begin
    A = [1 1; -1 0; 0 -1]
    b = [1, 0, 0]
    ls = BitSet([1])
    V = [0 1; 1 0]

    ine = hrep(A, b, ls)
    #@test !isempty(ine)
    inef = hrep(Array{Float64}(A), Array{Float64}(b), ls)
    #@test !isempty(inef)
    poly1 = CDDPolyhedra(ine)
    poly1f = CDDPolyhedra(inef)
    ineout1  = MixedMatHRep{Int}(copyinequalities(poly1 ))
    ineout1f = MixedMatHRep{Int}(copyinequalities(poly1f))
    extout1  = MixedMatVRep{Int}(  copygenerators(poly1 ))
    extout1f = MixedMatVRep{Int}(  copygenerators(poly1f))
    inequality_simpletest(ineout1, A, b, ls)
    inequality_simpletest(ineout1f, A, b, ls)
    generator_simpletest(extout1, V)
    generator_simpletest(extout1f, V)

    Aalt = [-1 -1; 1 0; -1 0]
    balt = [-1,1,0]
    linsetalt = BitSet([1])
    ext = vrep(V)
    extf = vrep(Array{Float64}(V))
    poly2 = CDDPolyhedra(ext)
    poly2f = CDDPolyhedra(extf)
    ineout2  = MixedMatHRep{Int}(copyinequalities(poly2 ))
    ineout2f = MixedMatHRep{Int}(copyinequalities(poly2f))
    extout2  = MixedMatVRep{Int}(  copygenerators(poly2 ))
    extout2f = MixedMatVRep{Int}(  copygenerators(poly2f))
    inequality_simpletest(ineout2, Aalt, balt, linsetalt)
    inequality_simpletest(ineout2f, Aalt, balt, linsetalt)
    generator_simpletest(extout2, V)
    generator_simpletest(extout2f, V)

    # x_1 cannot be 2
    #@test isempty(HRepresentation([A; 1 0], [b; 2], union(linset, BitSet([4]))))

    V0 = [0 0]
    ext0 = vrep(V0)
    ext0f = vrep(Array{Float64}(V0))
    push!(poly1, ext0)
    push!(poly1f, ext0f)
    push!(poly2, ext0)
    push!(poly2f, ext0)
    ineout3  = MixedMatHRep{Int}(copyinequalities(poly1 ))
    ineout3f = MixedMatHRep{Int}(copyinequalities(poly1f))
    extout3  = MixedMatVRep{Int}(  copygenerators(poly1 ))
    extout3f = MixedMatVRep{Int}(  copygenerators(poly1f))
    ineout4  = MixedMatHRep{Int}(copyinequalities(poly2 ))
    ineout4f = MixedMatHRep{Int}(copyinequalities(poly2f))
    extout4  = MixedMatVRep{Int}(  copygenerators(poly2 ))
    extout4f = MixedMatVRep{Int}(  copygenerators(poly2f))
    Vfull = [V;V0]
    linsetfull = BitSet()
    inequality_simpletest(ineout3, A, b, linsetfull)
    inequality_simpletest(ineout3f, A, b, linsetfull)
    generator_simpletest(extout3, Vfull)
    generator_simpletest(extout3f, Vfull)
    inequality_simpletest(ineout4, A, b, linsetfull)
    inequality_simpletest(ineout4f, A, b, linsetfull)
    generator_simpletest(extout4, Vfull)
    generator_simpletest(extout4f, Vfull)

    Rray = [1 0; 0 1]
    extray = vrep(zeros(Int, 1, 2), Rray)
    extrayf = vrep(zeros(Float64, 1, 2), Array{Float64}(Rray))
    generator_simpletest(extray, zeros(Int, 1, 2), Rray)
    generator_simpletest(extrayf, zeros(Int, 1, 2), Rray)
    polyray = CDDPolyhedra(extray)
    polyrayf = CDDPolyhedra(extrayf)
    Acut = [1 1]
    bcut = [1]
    linsetcut = BitSet([1])
    inecut = hrep(Acut, bcut, linsetcut)
    push!(polyray, inecut)
    push!(polyrayf, inecut)
    ineout5 = MixedMatHRep{Int}(copyinequalities(polyray))
    ineout5f = MixedMatHRep{Int}(copyinequalities(polyrayf))
    extout5 = MixedMatVRep{Int}(copygenerators(polyray))
    extout5f = MixedMatVRep{Int}(copygenerators(polyrayf))
    inequality_simpletest(ineout5, [Acut; 0 0; -1 0; 0 -1], [bcut; 1; 0; 0], BitSet([1]))
    inequality_simpletest(ineout5f, [Acut; 0 0; -1 0; 0 -1], [bcut; 1; 0; 0], BitSet([1]))
    generator_simpletest(extout5, V)
    generator_simpletest(extout5f, V)
    generator_simpletest(extout5, V, Array{Int}(undef, 0, 2))
    generator_simpletest(extout5f, V, Array{Int}(undef, 0, 2))
end
